<?php
/*******************************************************************
 *			
 * 			Fichier			:	envoi.php 
 * 			Cr le			:	12 aut 2002 
 * 			Dernire modif	:	17 avril 2003 
 * 			Email			:	wascripts@phpcodeur.net 
 * 
 * 				Copyright  2002-2003 phpCodeur
 * 
 *******************************************************************/

/*******************************************************************
 *  This program is free software; you can redistribute it and/or 
 * 	modify it under the terms of the GNU General Public License as 
 * 	published by the Free Software Foundation; either version 2 of 
 *  the License, or (at your option) any later version. 
 *******************************************************************/


define('IN_NEWSLETTER', true); 

require('./pagestart.php'); 

if( !$admindata['session_liste'] )
{
	$liste_id_ary = $auth->check_auth(AUTH_SEND); 
	
	if( !count($liste_id_ary) )
	{
		$message = $lang['Message']['No_liste_exists']; 
		
		if( $admindata['admin_level'] == ADMIN )
		{
			$message .= '<br /><br />' . sprintf($lang['Click_create_liste'], '<a href="' . sessid('view.php?mode=liste&amp;action=add') . '">', '</a>'); 
		}
		
		trigger_error($message, MESSAGE); 
	}
	
	include('./page_header.php'); 
	
	$template->set_filenames(array(
		'body' => 'select_liste_body.tpl'
	)); 
	
	$template->assign_vars(array(
		'L_TITLE' => $lang['Title']['select'],
		'L_SELECT_LISTE' => $lang['Choice_liste'],
		'L_VALID_BUTTON' => $lang['Button']['valid'],
		
		'LISTE_BOX' => build_listbox(AUTH_SEND),
		'S_HIDDEN_FIELDS' => '<input type="hidden" name="sessid" value="' . $session->session_id . '" />',
		'U_FORM' => sessid('envoi.php')
	)); 
	
	$template->pparse('body'); 
	
	include('./page_footer.php'); 
}
else
{
	$listdata = $auth->listdata[$admindata['session_liste']]; 
}

build_listbox('display', AUTH_SEND, 'envoi.php'); 

$mode = ( !empty($_POST['mode']) ) ? $_POST['mode'] : ( ( !empty($_GET['mode']) ) ? $_GET['mode'] : '' ); 
$id   = ( !empty($_POST['id']) ) ? intval($_POST['id']) : ( ( !empty($_GET['id']) ) ? intval($_GET['id']) : 0 ); 

$logdata = array(); 
$logdata['log_subject']	  = ( !empty($_POST['subject']) ) ? trim($_POST['subject']) : ''; 
$logdata['log_body_text'] = ( !empty($_POST['body_text']) ) ? trim($_POST['body_text']) : ''; 
$logdata['log_body_html'] = ( !empty($_POST['body_html']) ) ? trim($_POST['body_html']) : ''; 
$logdata['log_status'] 	  = ( !empty($_POST['log_status']) ) ? STATUS_HANDLE : STATUS_WRITING; 

if( isset($_POST['cancel']) )
{
	Location(sessid('envoi.php?mode=load&amp;id=' . $id)); 
}

if( isset($_POST['send']) )
{
	$mode = 'send'; 
}
else if( isset($_POST['save']) )
{
	$mode = 'save'; 
}
else if( isset($_POST['delete']) )
{
	$mode = 'delete'; 
}

$upload_on = false; 
if( $auth->check_auth(AUTH_ATTACH, $admindata['session_liste']) )
{
	if( isset($_POST['attach']) )
	{
		$mode = 'attach'; 
		
		$file_id = ( !empty($_POST['new_file_id']) ) ? intval($_POST['new_file_id']) : 0; 
	}
	else if( isset($_POST['unattach']) )
	{
		$file_id_ary = ( !empty($_POST['file_id']) ) ? $_POST['file_id'] : array(); 
		$file_id = 0; 
		
		foreach( $file_id_ary AS $tmp_id )
		{
			if( isset($_POST['unattach'][$tmp_id]) )
			{
				$file_id = $tmp_id; 
				break;
			}
		}
		
		if( $file_id )
		{
			$mode = 'unattach'; 
		}
	}
	
	$file_uploads_value = @ini_get('file_uploads'); 
	if( $file_uploads_value && strtolower($file_uploads_value) != 'off' )
	{
		$upload_on = true; 
	}
}

$error = false; 
$msg_error = array(); 

switch( $mode )
{
	case 'download':
		include($waroot . 'includes/class.attach.php'); 
		
		$attach = new Attach; 
		$attach->download_file($id); 
		break;
	
	case 'load':
	case 'resend':
		if( $mode == 'resend' )
		{
			$sql_where = ' AND log_status = ' . STATUS_STANDBY; 
		}
		else
		{
			$sql_where = ' AND ( log_status = ' . STATUS_WRITING . ' OR log_status = ' . STATUS_HANDLE . ' )'; 
		}
		
		if( isset($_POST['submit']) || $id )
		{
			$sql = "SELECT log_subject, log_body_text, log_body_html, log_status 
					FROM " . LOG_TABLE . " 
					WHERE log_id = " . $id . $sql_where; 
			if( !($result = $db->query($sql)) )
			{
				trigger_error('Impossible d\'obtenir les donnes sur ce log', ERROR); 
			}
			
			if( $row = $db->fetch_array($result) )
			{
				$logdata = $row; 
			}
			else
			{
				$meta = '<meta http-equiv="Refresh" content="4;url=' . sessid('envoi.php?mode=' . $mode) . '">'; 
				
				$message  = $lang['Message']['log_not_exists']; 
				$message .= '<br /><br />' . sprintf($lang['Click_return_back'], '<a href="' . sessid('envoi.php?mode=' . $mode) . '">', '</a>'); 
				trigger_error($message, MESSAGE); 
			}
		}
		else
		{
			$sql = "SELECT log_id, log_subject, log_status 
					FROM " . LOG_TABLE . " 
					WHERE liste_id = " . $admindata['session_liste'] . $sql_where . " 
					ORDER BY log_subject ASC"; 
			if( !($result = $db->query($sql)) )
			{
				trigger_error('Impossible d\'obtenir la liste des log', ERROR); 
			}
			
			if( $row = $db->fetch_array($result) )
			{
				$log_box = '<select name="id">'; 
				
				do
				{
					$status = ( $row['log_status'] == STATUS_HANDLE ) ? '[' . $lang['Handle'] . ']' : ''; 
					$log_box .= '<option value="' . $row['log_id'] . '"> - ' . htmlspecialchars($row['log_subject']) . ' ' . $status . ' - </option>'; 
				}
				while( $row = $db->fetch_array($result) ); 
				
				$log_box .= '</select>'; 
			}
			else
			{
				$meta = '<meta http-equiv="Refresh" content="4;url=' . sessid('envoi.php') . '">'; 
				
				$message  = ( $mode == 'load' ) ? $lang['Message']['No_log_to_load'] : $lang['Message']['No_log_to_send']; 
				$message .= '<br /><br />' . sprintf($lang['Click_return_form'], '<a href="' . sessid('envoi.php') . '">', '</a>'); 
				trigger_error($message, MESSAGE); 
			}
			
			$s_hidden_fields  = '<input type="hidden" name="mode" value="' . $mode . '" />'; 
			$s_hidden_fields .= '<input type="hidden" name="sessid" value="' . $session->session_id . '" />'; 
			
			include('./page_header.php'); 
			
			$template->set_filenames(array(
				'body' => 'select_log_body.tpl'
			)); 
			
			$template->assign_vars(array(
				'L_TITLE' => $lang['Title']['select'],
				'L_SELECT_LOG' => ( $mode == 'load' ) ? $lang['Select_log_to_load'] : $lang['Select_log_to_send'],
				'L_VALID_BUTTON' => $lang['Button']['valid'],
				
				'LOG_BOX' => $log_box,
				'S_HIDDEN_FIELDS' => $s_hidden_fields,
				'U_FORM' => sessid('envoi.php')
			)); 
			
			$template->pparse('body'); 
			
			include('./page_footer.php'); 
		}
		break;
	
	case 'delete':
		if( !$id )
		{
			$meta = '<meta http-equiv="Refresh" content="4;url=' . sessid('envoi.php') . '">'; 
			
			$message  = $lang['Message']['No_log_id']; 
			$message .= '<br /><br />' . sprintf($lang['Click_return_back'], '<a href="' . sessid('envoi.php') . '">', '</a>'); 
			trigger_error($message, MESSAGE); 
		}
		
		if( isset($_POST['confirm']) )
		{
			$db->transaction(START_TRC); 
			
			$sql = 'DELETE FROM ' . LOG_TABLE . ' 
					WHERE log_id = ' . $id; 
			if( !$db->query($sql) )
			{
				trigger_error('Impossible de supprimer le log', ERROR); 
			}
			
			include($waroot . 'includes/class.attach.php'); 
			
			$attach = new Attach; 
			$attach->delete_joined_files(true, $id); 
			
			$db->transaction(END_TRC); 
			
			$meta = '<meta http-equiv="Refresh" content="4;url=' . sessid('envoi.php') . '">'; 
			
			$message  = $lang['Message']['log_deleted']; 
			$message .= '<br /><br />' . sprintf($lang['Click_return_back'], '<a href="' . sessid('envoi.php') . '">', '</a>'); 
			trigger_error($message, MESSAGE); 
		}
		else
		{
			$s_hidden_fields  = '<input type="hidden" name="mode" value="delete" />'; 
			$s_hidden_fields .= '<input type="hidden" name="sessid" value="' . $session->session_id . '" />'; 
			$s_hidden_fields .= '<input type="hidden" name="id" value="' . $id . '" />'; 
			
			include('./page_header.php'); 
			
			$template->set_filenames(array(
				'body' => 'confirm_body.tpl'
			)); 
			
			$template->assign_vars(array(
				'L_CONFIRM' => $lang['Title']['confirm'],
				
				'TEXTE' => $lang['Delete_log'],
				'L_YES' => $lang['Yes'],
				'L_NO'  => $lang['No'],
				
				'S_HIDDEN_FIELDS' => $s_hidden_fields,
				'U_FORM' => sessid('envoi.php')
			)); 
			
			$template->pparse('body'); 
			
			include('./page_footer.php'); 
		}
		break;
	
	case 'attach':
	case 'send':
	case 'save':
		if( ( $mode == 'attach' && empty($id) ) || $mode == 'send' || $mode == 'save' )
		{
			if( $logdata['log_subject'] == '' )
			{
				$error = true; 
				$msg_error[] = $lang['Subject_empty']; 
			}
			
			if( $listdata['liste_format'] != FORMAT_HTML && $logdata['log_body_text'] == '' )
			{
				$error = true; 
				$msg_error[] = $lang['Body_empty']; 
			}
			
			if( $listdata['liste_format'] != FORMAT_TEXTE && $logdata['log_body_html'] == '' )
			{
				$error = true; 
				$msg_error[] = $lang['Body_empty']; 
			}
			
			if( $mode == 'send' )
			{
				if( $listdata['liste_format'] != FORMAT_HTML && !strstr($logdata['log_body_text'], '{LINKS}') )
				{
					$error = TRUE; 
					$msg_error[] = $lang['No_links_in_body']; 
				}
				
				if( $listdata['liste_format'] != FORMAT_TEXTE && !strstr($logdata['log_body_html'], '{LINKS}') )
				{
					$error = TRUE; 
					$msg_error[] = $lang['No_links_in_body']; 
				}
			}
			
			if( !$error )
			{
				$sql_where = ''; 
				
				if( $mode == 'send' && $logdata['log_status'] == STATUS_WRITING )
				{
					$logdata['log_status'] = STATUS_STANDBY; 
				}
				
				$logdata['log_date'] = time(); 
				$logdata['liste_id'] = $admindata['session_liste']; 
				
				if( empty($id) )
				{
					$sql_type = 'INSERT'; 					
				}
				else
				{
					$sql_type = 'UPDATE'; 
					$sql_where = array('log_id' => $id, 'liste_id' => $admindata['session_liste']); 
				}
				
				if( !$db->query_build($sql_type, LOG_TABLE, $logdata, $sql_where) )
				{
					trigger_error('Impossible de sauvegarder la newsletter', ERROR); 
				}
				
				if( $sql_type == 'INSERT' )
				{
					$id = $db->next_id(); 
				}
				
				if( $mode == 'send' && $logdata['log_status'] == STATUS_HANDLE )
				{
					if( $sql_type == 'UPDATE' )
					{
						$sql = "SELECT file_id FROM " . LOG_FILES_TABLE . " WHERE log_id = " . $id; 
					}
					
					$logdata['log_status'] = STATUS_STANDBY; 
					
					if( !$db->query_build('INSERT', LOG_TABLE, $logdata) )
					{
						trigger_error('Impossible de dupliquer la newsletter', ERROR); 
					}
					
					$id = $db->next_id(); 
					
					if( !($result = $db->query($sql)) )
					{
						trigger_error('Impossible d\'obtenir les fichiers joints de ce log', ERROR); 
					}
					
					while( $row = $db->fetch_array($result) )
					{
						$db->query("INSERT INTO " . LOG_FILES_TABLE . " (log_id, file_id) VALUES($id, " . $row['file_id'] . ")"); 
					}
				}
				else if( $mode == 'save' )
				{
					$meta = '<meta http-equiv="Refresh" content="4;url=' . sessid('envoi.php?mode=load&amp;id=' . $id) . '">'; 
					
					$message  = $lang['Message']['log_saved']; 
					$message .= '<br /><br />' . sprintf($lang['Click_return_back'], '<a href="' . sessid('envoi.php?mode=load&amp;id=' . $id) . '">', '</a>'); 
					trigger_error($message, MESSAGE); 
				}
			}
		}
		
		if( $mode == 'attach' && !empty($id) )
		{
			if( $file_id )
			{
				$filedata = $file_id; 
				$allready_on_server = true; 
			}
			else if( $upload_on && !empty($_FILES['join_file']) )
			{
				$filedata = $_FILES['join_file']; 
				$allready_on_server = false; 
			}
			else
			{
				$filedata = ( !empty($_POST['join_file']) ) ? trim($_POST['join_file']) : 'blob.blob'; 
				$allready_on_server = true; 
			}
			
			include($waroot . 'includes/class.attach.php'); 
			
			$attach = new Attach; 
			$attach->upload_file($filedata, $id, $error, $msg_error, $allready_on_server); 
		}
		break;
	
	case 'unattach':
		include($waroot . 'includes/class.attach.php'); 
		
		$attach = new Attach; 
		$attach->delete_joined_files(false, $id, $file_id); 
		break;
}

$file_box = ''; 
$logdata['joined_files'] = array(); 

if( $auth->check_auth(AUTH_ATTACH, $admindata['session_liste']) )
{
	$sql = "SELECT lf.log_id, jf.file_id, jf.file_real_name, jf.file_physical_name, jf.file_size, jf.file_mimetype 
			FROM " . JOINED_FILES_TABLE . " AS jf, " . LOG_FILES_TABLE . " AS lf, " . LOG_TABLE . " AS l 
			WHERE jf.file_id = lf.file_id AND lf.log_id = l.log_id 
			  AND l.liste_id = " . $admindata['session_liste'] . " 			
			ORDER BY jf.file_real_name ASC"; 
	if( !($result = $db->query($sql)) )
	{
		trigger_error('Impossible d\'obtenir la liste des fichiers joints', ERROR); 
	}
	
	$other_files = $joined_files_id = array(); 
	
	while( $row = $db->fetch_array($result) )
	{
		if( $row['log_id'] == $id )
		{
			$logdata['joined_files'][] = $row; 
			$joined_files_id[] = $row['file_id']; 
		}
		else
		{
			$other_files[$row['file_id']] = $row; 
		}
	}
		
	foreach( $other_files AS $tmp_id => $row )
	{
		if( !in_array($tmp_id, $joined_files_id) )
		{
			$file_box .= '<option value="' . $tmp_id . '"> - ' . htmlspecialchars($row['file_real_name']) . ' - </option>'; 
		}
	}
	
	if( $file_box != '' )
	{
		$file_box = '<i>ou</i> <select name="new_file_id"><option value="0"> - ' . $lang['File_on_server'] . ' - </option>' . $file_box . '</select>'; 
	}
	
	unset($other_files, $joined_files_id); 
}

if( ( $mode == 'send' || $mode == 'resend' ) && !$error )
{
	$subject 	= stripslashes($logdata['log_subject']); 
	$body_text	= stripslashes($logdata['log_body_text']); 
	$body_html	= stripslashes($logdata['log_body_html']); 
	
	if( $nl_config['engine_send'] == ENGINE_BCC )
	{
		if( $listdata['liste_format'] != FORMAT_HTML )
		{
			$body_text = str_replace('{LINKS}', $listdata['form_url'], $body_text);
		}
		
		if( $listdata['liste_format'] != FORMAT_TEXTE )
		{
			$body_html = str_replace('{LINKS}', '<a href="' . $listdata['form_url'] . '">' . $listdata['form_url'] . '</a>', $body_html);
		}
	}
	else
	{
		$link  = $listdata['form_url']; 
		$link .= ( strstr($listdata['form_url'], '?') ) ? '&' : '?'; 
		$link .= 'action=desinscription&email={EMAIL}&code={CODE}&liste=' . $admindata['session_liste']; 
		
		$link_text = $link; 
		$link_html = '<a href="' . $link . '">' . $link . '</a>'; 
		
		unset($link); 
	}
	
	if( $mode == 'send' )
	{
		$sql = "UPDATE " . ABO_LISTE_TABLE . " SET send = 0 
			WHERE liste_id = " . $admindata['session_liste']; 
		if( !($result = $db->query($sql)) )
		{
			trigger_error('Impossible de mettre  jour la table des abonns', ERROR); 
		}
	}
	
	//
	// On augmente le temps d'excution du script 
	// Certains hbergeurs empchent pour des raisons videntes cette possibilit
	// Si c'est votre cas, vous tes mal barr 
	//
	@set_time_limit(1200); 
	
	//
	// Si les fichiers joints sont stocks sur un ftp, on les rapatrie sur le serveur 
	// le temps de l'envoi 
	//
	if( $nl_config['use_ftp'] )
	{
		// TODO ramener les fichirs du ftp dans dossier temporaire
	}
	
	include_once($waroot . 'includes/class.mailer.php'); 
	
	$mailer = new Mailer(); 
	
	if( $nl_config['use_smtp'] )
	{
		$mailer->set_smtp(
			$nl_config['smtp_host'],
			$nl_config['smtp_port'],
			$nl_config['smtp_user'],
			$nl_config['smtp_pass']
		);
	}
	
	$mailer->hebergeur = $nl_config['hebergeur']; 
	$mailer->charset   = $lang['CHARSET']; 
	
	$mailer->set_subject($subject); 
	$mailer->set_from($listdata['sender_email'], unhtmlspecialchars($listdata['liste_name'])); 
	
	foreach( $logdata['joined_files'] AS $filedata )
	{
		$mailer->attachment(
			$waroot . $nl_config['upload_path'] . $filedata['file_physical_name'],
			$filedata['file_real_name'],
			'attachment',
			$filedata['file_mimetype']
		); 
	}
	
	$sql_where = ''; 
	if( $nl_config['emails_sended'] > 0 )
	{
		$sql_where = ' LIMIT 0, ' . $nl_config['emails_sended']; 
	}
	
	$sql = "SELECT a.abo_id, a.abo_email, a.abo_register_key, al.format 
			FROM " . ABONNES_TABLE . " AS a, " . ABO_LISTE_TABLE . " AS al 
			WHERE al.liste_id = " . $admindata['session_liste'] . " 
			  AND a.abo_id = al.abo_id AND al.send = 0 AND a.abo_status = " . ABO_ACTIF . $sql_where; 
	if( !($result = $db->query($sql)) )
	{
		trigger_error('Impossible d\'obtenir la liste des abonns', ERROR); 
	}
	
	$num_subscribers = $db->num_rows($result); 
	
	if( $num_subscribers > 0 )
	{
		if( $nl_config['engine_send'] == ENGINE_BCC )
		{
			$abonnes_text = array(); 
			$abonnes_html = array(); 
			$abo_id_ary	  = array(); 
			
			while( $row = $db->fetch_array($result) )
			{
				if( ( $listdata['liste_format'] == FORMAT_MULTIPLE && $row['format'] == FORMAT_HTML ) || $listdata['liste_format'] == FORMAT_HTML )
				{
					$abonnes_html[] = $row['abo_email']; 
				}
				else if( ( $listdata['liste_format'] == FORMAT_MULTIPLE && $row['format'] == FORMAT_TEXTE ) || $listdata['liste_format'] == FORMAT_TEXTE )
				{
					$abonnes_text[] = $row['abo_email']; 
				}
				
				$abo_id_ary[]	= $row['abo_id']; 
			}
			
			if( count($abonnes_text) )
			{
				$mailer->set_to($abonnes_text, 'bcc'); 
				$mailer->set_format(FORMAT_TEXTE); 
				$mailer->set_message($body_text); 
				
				if( !$mailer->send() )
				{
					trigger_error(sprintf($lang['Message']['Failed_sending2'], $mailer->mail_reponse), ERROR); 
				}
			}
			
			if( count($abonnes_html) )
			{
				$mailer->set_to($abonnes_html, 'bcc'); 
				$mailer->set_format(FORMAT_HTML); 
				$mailer->set_message($body_html); 
				
				if( !$mailer->send() )
				{
					trigger_error(sprintf($lang['Message']['Failed_sending2'], $mailer->mail_reponse), ERROR); 
				}
			}
		}
		else if( $nl_config['engine_send'] == ENGINE_UNIQ )
		{
			$abodata 	  = array(); 
			$abo_id_ary	  = array(); 
			
			$i = 0; 
			while( $row = $db->fetch_array($result) )
			{
				if( ( $listdata['liste_format'] == FORMAT_MULTIPLE && $row['format'] == FORMAT_HTML ) || $listdata['liste_format'] == FORMAT_HTML )
				{
					$format = FORMAT_HTML; 
				}
				else if( ( $listdata['liste_format'] == FORMAT_MULTIPLE && $row['format'] == FORMAT_TEXTE ) || $listdata['liste_format'] == FORMAT_TEXTE )
				{
					$format = FORMAT_TEXTE; 
				}
				
				$abodata[$i]['email']	= $row['abo_email']; 
				$abodata[$i]['code']	= $row['abo_register_key']; 
				$abodata[$i]['format']	= $format; 
				
				$abo_id_ary[]	= $row['abo_id']; 
				
				$i++; 
			}
			
			for( $i = 0; $i < $num_subscribers; $i++ )
			{
				if( $abodata[$i]['format'] == FORMAT_HTML )
				{
					$body_tmp = $body_html; 
					$link_tmp = $link_html; 
					$format	  = FORMAT_HTML; 
				}
				else
				{
					$body_tmp = $body_text; 
					$link_tmp = $link_text; 
					$format	  = FORMAT_TEXTE; 
				}
				
				$mailer->clear_to(); 
				$mailer->set_to($abodata[$i]['email']); 
				
				if( $listdata['return_email'] != '' )
				{
					$mailer->set_return_path($listdata['return_email']); 
				}
				
				$link_tmp = str_replace('{CODE}', $abodata[$i]['code'], $link_tmp); 
				$link_tmp = str_replace('{EMAIL}', $abodata[$i]['email'], $link_tmp); 
				$body_tmp = str_replace('{LINKS}', $link_tmp, $body_tmp); 
				
				$mailer->set_format($format); 
				$mailer->set_message($body_tmp); 
				
				if( !$mailer->send() )
				{
					trigger_error(sprintf($lang['Message']['Failed_sending2'], $mailer->mail_reponse), ERROR); 
				}
			}
		}
	}
	else
	{
		trigger_error('No_subscribers', MESSAGE); 
	}
	$db->free_result($result); 
	
	$sql = "UPDATE " . ABO_LISTE_TABLE . " SET send = 1 
		WHERE abo_id IN(" . implode(', ', $abo_id_ary) . ") 
		  AND liste_id = " . $admindata['session_liste']; 
	if( !$db->query($sql) )
	{
		unset($db); 
		$db = new sql($dbhost, $dbuser, $dbpassword, $dbname);
		if( !$db->connect_id || !$db->query($sql) )
		{
			trigger_error('Impossible de mettre  jour la table des abonns', ERROR); 
		}
	}
	
	$sql = "SELECT COUNT(*) AS num_dest, al.send 
			FROM " . ABONNES_TABLE . " AS a, " . ABO_LISTE_TABLE . " AS al 
			WHERE al.liste_id = " . $admindata['session_liste'] . " 
			  AND a.abo_id = al.abo_id AND a.abo_status = " . ABO_ACTIF . " 
			GROUP BY al.send"; 
	if( !($result = $db->query($sql)) )
	{
		trigger_error('Impossible d\'obtenir le nombre d\'envois restants  faire', ERROR); 
	}
	
	$no_send = $num_dest = 0; 
	
	while( $row = $db->fetch_array($result) )
	{
		if( $row['send'] == 1 )
		{
			$num_dest = $row['num_dest']; 
		}
		else
		{
			$no_send = $row['num_dest']; 
		}
	}
	$db->free_result($result); 
	
	$message = sprintf($lang['Message']['Success_send'], $num_subscribers); 
	
	if( $no_send > 0 )
	{
		$step = ( !empty($_GET['step']) ) ? $_GET['step'] : ''; 
		
		if( $step == 'auto' )
		{
			Location(sessid('envoi.php?resend=1&id=' . $id . '&step=auto')); 
		}
		
		$message .= '<br /><br />' .  sprintf($lang['Click_resend_auto'], '<a href="' . sessid('envoi.php?resend=1&amp;id=' . $id . '&amp;step=auto') . '">', '</a>'); 
		$message .= '<br /><br />' .  sprintf($lang['Click_resend_manuel'], '<a href="' . sessid('envoi.php?resend=1&amp;id=' . $id) . '">', '</a>'); 
	}
	else
	{
		$sql = "UPDATE " . ABO_LISTE_TABLE . " SET send = 0 
			WHERE liste_id = " . $admindata['session_liste']; 
		if( !$db->query($sql) )
		{
			trigger_error('Impossible de mettre  jour la table des abonns', ERROR); 
		}
		
		$sql = "UPDATE " . LOG_TABLE . " 
			SET log_status = " . STATUS_SENDED . " 
			WHERE log_id = " . $id; 
		if( !$db->query($sql) )
		{
			trigger_error('Impossible de mettre  jour la table des logs', ERROR); 
		}
	}
	
	trigger_error($message, MESSAGE); 
}

if( $error )
{
	error_box($msg_error); 
}

$s_hidden_fields  = '<input type="hidden" name="id" value="' . $id . '" />'; 
$s_hidden_fields .= '<input type="hidden" name="sessid" value="' . $session->session_id . '" />'; 

include('./page_header.php'); 

$template->set_filenames(array(
	'body' => 'send_body.tpl'
)); 

$template->assign_vars(array(
	'L_EXPLAIN' => $lang['Explain']['send'],	
	'L_LOAD_LOG' => $lang['Load_log'],
	'L_RESEND_LOG' => $lang['Resend_log'],
	'L_DEST' => $lang['Dest'],
	'L_SUBJECT' => $lang['Log_subject'],
	'L_BODY_TEXT' => $lang['Log_in_text'],
	'L_BODY_HTML' => $lang['Log_in_html'],
	'L_LINK' => $lang['Button']['links'],
	'L_EMPTY_SUBJECT' => str_replace('\'', '\\\'', $lang['Subject_empty']),
	'L_EMPTY_BODY' => str_replace('\'', '\\\'', $lang['Body_empty']),
	'L_LOAD_PAGE' => str_replace('\'', '\\\'', $lang['Wait_loading']),
	'L_STATUS' => $lang['Status'],
	'L_STATUS_WRITING' => $lang['Status_writing'],
	'L_STATUS_HANDLE' => $lang['Status_handle'],
	'L_SEND_BUTTON' => $lang['Button']['send'],
	'L_SAVE_BUTTON' => $lang['Button']['save'],
	'L_DELETE_BUTTON' => $lang['Button']['delete'],
	'L_PREVIEW_BUTTON' => $lang['Button']['preview'],
	
	'LINKS' => '{LINKS}',
	'S_DEST' => $listdata['liste_name'],
	'S_SUBJECT' => htmlspecialchars(stripslashes($logdata['log_subject'])),
	'SELECTED_STATUS_WRITING' => ( $logdata['log_status'] == STATUS_WRITING ) ? ' selected="selected"' : '',
	'SELECTED_STATUS_HANDLE' => ( $logdata['log_status'] == STATUS_HANDLE ) ? ' selected="selected"' : '',
	
	'S_ENCTYPE' => ( $upload_on ) ? 'enctype="multipart/form-data"' : '',	
	'S_HIDDEN_FIELDS' => $s_hidden_fields
)); 

if( $listdata['liste_format'] != FORMAT_HTML )
{
	$template->assign_block_vars('formulaire', array(
		'L_TITLE' => $lang['Log_in_text'],
		'L_EXPLAIN_BODY' => $lang['Explain']['text'],
		
		'S_TEXTAREA_NAME' => 'body_text',
		'S_BODY' => htmlspecialchars(stripslashes($logdata['log_body_text'])),
		'S_FORMAT' => FORMAT_TEXTE
	)); 
}

if( $listdata['liste_format'] != FORMAT_TEXTE )
{
	$template->assign_block_vars('formulaire', array(
		'L_TITLE' => $lang['Log_in_html'],
		'L_EXPLAIN_BODY' => $lang['Explain']['html'],
		
		'S_TEXTAREA_NAME' => 'body_html',
		'S_BODY' => htmlspecialchars(stripslashes($logdata['log_body_html'])),
		'S_FORMAT' => FORMAT_HTML
	)); 
}

if( $auth->check_auth(AUTH_ATTACH, $admindata['session_liste']) )
{
	$template->set_filenames(array(
		'joined_files_box' => 'joined_files_box_body.tpl'
	)); 
	
	$template->assign_vars(array(
		'L_TITLE_ADD_FILE' => $lang['Title']['join'],
		'L_EXPLAIN_ADD_FILE' => $lang['Explain']['join'],
		'L_ADD_FILE' => $lang['Join_file_to_log'],
		'L_ADD_FILE_BUTTON' => $lang['Button']['add_file'],
		'L_DELETE_FILE_BUTTON' => $lang['Button']['del_file'],
		
		'FILE_BOX' => $file_box,
		'S_TYPE_INPUT' => ( $upload_on ) ? 'file' : 'text',
		'S_SESSID' => $session->session_id
	)); 
	
	if( count($logdata['joined_files']) )
	{
		$total_log_size  = 1024; // 1024 correspond au poids de base d'un email (enttes) 
		
		$body_size = strlen($logdata['log_body_text']) + strlen($logdata['log_body_html']); 
		
		$total_log_size += ( $body_size ) ? $body_size/2 : 0; 
		
		for( $i = 0; $i < count($logdata['joined_files']); $i++ )
		{
			$total_log_size += $logdata['joined_files'][$i]['file_size']; 
		}
		
		if( $total_log_size >= 1048576 )
		{
			$l_total_log_size = sprintf("%.2f Mo", ($total_log_size / 1048576));
		}
		else if( $total_log_size >= 1024 )
		{
			$l_total_log_size = sprintf("%.2f Ko", ($total_log_size / 1024));
		}
		else
		{
			$l_total_log_size = sprintf("%.2f " . $lang['Octets'], $total_log_size);
		}
		
		$template->assign_block_vars('joined_files', array(
			'L_TITLE_FILES_LIST' => $lang['Title']['joined_files'],
			'L_NAME' => $lang['Filename'],
			'L_SIZE' => $lang['Filesize'],
			'L_TOTAL_LOG_SIZE' => $lang['Total_log_size'],
			
			'S_TOTAL_LOG_SIZE' => $l_total_log_size
		)); 
		
		for( $i = 0; $i < count($logdata['joined_files']); $i++ )
		{
			$filesize = $logdata['joined_files'][$i]['file_size']; 
			$filename = $logdata['joined_files'][$i]['file_real_name']; 
			$file_id  = $logdata['joined_files'][$i]['file_id']; 
			$mimetype = $logdata['joined_files'][$i]['file_mimetype']; 
			
			$total_log_size += $filesize; 
			
			if( $filesize >= 1048576 )
			{
				$l_filesize = sprintf("%.2f Mo", ($filesize / 1048576));
			}
			else if( $filesize >= 1024 )
			{
				$l_filesize = sprintf("%.2f Ko", ($filesize / 1024));
			}
			else
			{
				$l_filesize = sprintf("%.2f " . $lang['Octets'], $filesize);
			}
			
			if( ereg('^image/(gif|jpg|jpeg|bmp|pjpeg)$', $mimetype) )
			{
				$s_show  = '<a href="javascript:show(' . $file_id . ')">'; 
				$s_show .= '<img src="' . $waroot . '/images/icon_loupe.gif" border="0" alt="' . $lang['Show'] . '" title="' . $lang['Show'] . '" /></a>'; 
				$s_show .= '</a>'; 
			}
			else
			{
				$s_show = ''; 
			}
			
			$template->assign_block_vars('joined_files.file_info', array(
				'OFFSET' => ($i+1),
				'FILE_ID' => $file_id,
				'FILENAME' => htmlspecialchars($filename),
				'FILESIZE' => $l_filesize,
				'S_SHOW' => $s_show
			)); 
		}
	}
	
	$template->assign_var_from_handle('JOINED_FILES_BOX', 'joined_files_box'); 
}

$template->pparse('body'); 

include('./page_footer.php'); 
?>