<?php
/*******************************************************************
 *			
 * 			Fichier			:	tools.php 
 * 			Cr le			:	24 octobre 2002 
 * 			Dernire modif	:	16 avril 2003 
 * 			Email			:	wascripts@phpcodeur.net 
 * 
 * 				Copyright  2002-2003 phpCodeur
 * 
 *******************************************************************/

/*******************************************************************
 *  This program is free software; you can redistribute it and/or 
 * 	modify it under the terms of the GNU General Public License as 
 * 	published by the Free Software Foundation; either version 2 of 
 *  the License, or (at your option) any later version. 
 *******************************************************************/


define('IN_NEWSLETTER', true); 

require('./pagestart.php'); 

/*
 * Classe zip importe de phpMyAdmin 2.5.0-rc1 
 * 
 * Zip file creation class.
 * Makes zip files.
 *
 * Based on :
 *
 *  http://www.zend.com/codex.php?id=535&single=1
 *  By Eric Mueller <eric@themepark.com>
 *
 *  http://www.zend.com/codex.php?id=470&single=1
 *  by Denis125 <webmaster@atlant.ru>
 *
 *  a patch from Peter Listiak <mlady@users.sourceforge.net> for last modified
 *  date and time of the compressed file
 *
 * Official ZIP file format: http://www.pkware.com/appnote.txt
 *
 * @access  public
 */
class zipfile {
	
    var $datasec      = array(); 
    var $ctrl_dir     = array(); 
    var $eof_ctrl_dir = "\x50\x4b\x05\x06\x00\x00\x00\x00"; 
    var $old_offset   = 0; 
	
    function unix2DosTime($unixtime = 0)
	{
        $timearray = ($unixtime == 0) ? getdate() : getdate($unixtime); 
		
        if ($timearray['year'] < 1980)
		{
        	$timearray['year']    = 1980;
        	$timearray['mon']     = 1;
        	$timearray['mday']    = 1;
        	$timearray['hours']   = 0;
        	$timearray['minutes'] = 0;
        	$timearray['seconds'] = 0;
        } // end if
		
        return (($timearray['year'] - 1980) << 25) | ($timearray['mon'] << 21) | ($timearray['mday'] << 16) |
                ($timearray['hours'] << 11) | ($timearray['minutes'] << 5) | ($timearray['seconds'] >> 1);
    }
	
    function addFile($data, $name, $time = 0)
    {
        $name     = str_replace('\\', '/', $name);

        $dtime    = dechex($this->unix2DosTime($time));
        $hexdtime = '\x' . $dtime[6] . $dtime[7]
                  . '\x' . $dtime[4] . $dtime[5]
                  . '\x' . $dtime[2] . $dtime[3]
                  . '\x' . $dtime[0] . $dtime[1];
        eval('$hexdtime = "' . $hexdtime . '";');

        $fr    = "\x50\x4b\x03\x04";
        $fr   .= "\x14\x00";            // ver needed to extract
        $fr   .= "\x00\x00";            // gen purpose bit flag
        $fr   .= "\x08\x00";            // compression method
        $fr   .= $hexdtime;             // last mod time and date

        // "local file header" segment
        $unc_len = strlen($data);
        $crc     = crc32($data);
        $zdata   = gzcompress($data);
        $zdata   = substr(substr($zdata, 0, strlen($zdata) - 4), 2); // fix crc bug
        $c_len   = strlen($zdata);
        $fr      .= pack('V', $crc);             // crc32
        $fr      .= pack('V', $c_len);           // compressed filesize
        $fr      .= pack('V', $unc_len);         // uncompressed filesize
        $fr      .= pack('v', strlen($name));    // length of filename
        $fr      .= pack('v', 0);                // extra field length
        $fr      .= $name;
		
        // "file data" segment
        $fr .= $zdata;
		
        // "data descriptor" segment (optional but necessary if archive is not
        // served as file)
        $fr .= pack('V', $crc);                 // crc32
        $fr .= pack('V', $c_len);               // compressed filesize
        $fr .= pack('V', $unc_len);             // uncompressed filesize
		
        // add this entry to array
        $this->datasec[] = $fr;
        $new_offset      = strlen(implode('', $this->datasec));
		
        // now add to central directory record
        $cdrec  = "\x50\x4b\x01\x02";
        $cdrec .= "\x00\x00";                // version made by
        $cdrec .= "\x14\x00";                // version needed to extract
        $cdrec .= "\x00\x00";                // gen purpose bit flag
        $cdrec .= "\x08\x00";                // compression method
        $cdrec .= $hexdtime;                 // last mod time & date
        $cdrec .= pack('V', $crc);           // crc32
        $cdrec .= pack('V', $c_len);         // compressed filesize
        $cdrec .= pack('V', $unc_len);       // uncompressed filesize
        $cdrec .= pack('v', strlen($name));  // length of filename
        $cdrec .= pack('v', 0);              // extra field length
        $cdrec .= pack('v', 0);              // file comment length
        $cdrec .= pack('v', 0);              // disk number start
        $cdrec .= pack('v', 0);              // internal file attributes
        $cdrec .= pack('V', 32);             // external file attributes - 'archive' bit set

        $cdrec .= pack('V', $this->old_offset); // relative offset of local header
        $this->old_offset = $new_offset;

        $cdrec .= $name;

        // optional extra field, file comment goes here
        // save to central directory
        $this->ctrl_dir[] = $cdrec;
    }
	
    function file()
    {
        $data    = implode('', $this->datasec);
        $ctrldir = implode('', $this->ctrl_dir);

        return
            $data .
            $ctrldir .
            $this->eof_ctrl_dir .
            pack('v', sizeof($this->ctrl_dir)) .  // total # of entries "on this disk"
            pack('v', sizeof($this->ctrl_dir)) .  // total # of entries overall
            pack('V', strlen($ctrldir)) .         // size of central dir
            pack('V', strlen($data)) .            // offset to start of central dir
            "\x00\x00";                           // .zip file comment length
    }
}

function get_table_structure($table_name, $type, $drop_option)
{
	global $db; 
	
	$contents = ''; 	
	if( $drop_option )
	{
		$contents .= "DROP TABLE IF EXISTS $table_name;\n"; 
	}	
	
	$result = $db->query('SHOW CREATE TABLE ' . $table_name); 
	
	if( $result )
	{
		$contents .= $db->result($result, 0, 'Create Table'); 
		$db->free_result($result); 
	}
	else
	{
		$contents .= "CREATE TABLE $table_name(\n"; 
		
		$result = $db->query("SHOW FIELDS FROM $table_name"); 
		
		$end_line = false; 
		while( $row = $db->fetch_array($result) )
		{
			if( $end_line )
			{
				$contents .= ",\n"; 
			}
			
			$contents .= "\t" . $row['Field'] . ' ' . $row['Type']; 
			$contents .= ( !empty($row['Default']) ) ? ' DEFAULT \'' . $row['Default'] . '\'' : ''; 
			$contents .= ( $row['Null'] != 'YES' ) ? ' NOT NULL' : ''; 
			$contents .= ( $row['Extra'] != '' ) ? ' ' . $row['Extra'] : ''; 
			
			$end_line = true; 
		}
		$db->free_result($result); 
		
		$result = $db->query("SHOW KEYS FROM $table_name"); 
		
		$index = array(); 
		
		while( $row = $db->fetch_array($result) )
		{
			$name = $row['Key_name']; 
			
			if( $name != 'PRIMARY' && $row['Non_unique'] == 0 )
			{
				$name = 'unique_' . $name; 
			}
			
			if( !isset($index[$name]) )
			{
				$index[$name] = array(); 
			}
			
			$index[$name][] = $row['Column_name']; 
		}
		$db->free_result($result); 
		
		foreach( $index AS $var => $columns )
		{
			$contents .= ",\n\t"; 
			
			if( $var == 'PRIMARY' )
			{
				$contents .= 'PRIMARY KEY'; 
			}
			else if( ereg('^unique_(.+)$', $var, $regs) )
			{
				$contents .= 'UNIQUE ' . $regs[1]; 
			}
			else
			{
				$contents .= 'KEY ' . $var; 
			}
			
			$contents .= ' (' . implode(', ', $columns) . ')'; 
		}
		
		$contents .= "\n)" . ( ( !empty($type) ) ? ' TYPE=' . $type : '' ); 
	}
	
	$contents .= ";\n"; 
	
	return $contents; 
}

function compress_filedata(&$filename, &$mime_type, $contents, $compress)
{
	switch( $compress )
	{
		case 'zip':
			$mime_type = 'application/x-zip-compressed'; 
			$zip = new zipfile; 
			$zip->addFile($contents, $filename, time()); 
			$contents  = $zip->file(); 
			$filename .= '.zip'; 
			break;
		
		case 'gzip':
			$mime_type = 'application/x-gzip-compressed'; 
			$contents  = gzencode($contents); 
			$filename .= '.gz'; 
			break;
		
		case 'bz2':
			$mime_type = 'application/x-bzip'; 
			$contents  = bzcompress($contents); 
			$filename .= '.bz2'; 
			break;
		
		default:
			$mime_type = 'text/x-delimtext'; 
			break;
	}
	
	return $contents; 
}

function decompress_filedata($filename, $file_ext)
{
	switch( $file_ext )
	{
		case 'gz':
			$open  = 'gzopen'; 
			$eof   = 'gzeof'; 
			$gets  = 'gzgets'; 
			$close = 'gzclose'; 
			break;
		
		case 'bz2':
		case 'txt':
			$open  = 'fopen'; 
			$eof   = 'feof'; 
			$gets  = 'fgets'; 
			$close = 'fclose'; 
			break;
	}
	
	if( !($fp = @$open($filename, 'rb')) )
	{
		trigger_error('Failed_open_file', ERROR); 
	}
	
	$data = ''; 
	while( !@$eof($fp) )
	{
		$data .= $gets($fp, 1024); 
	}
	$close($fp); 
	
	if( $file_ext == 'bz2' )
	{
		$data = bzdecompress($data); 
	}
	
	return $data; 
}

$mode 	  = ( !empty($_GET['mode']) ) ? $_GET['mode'] : ''; 
$format	  = ( !empty($_POST['format']) ) ? max(intval($_POST['format']), FORMAT_TEXTE) : FORMAT_TEXTE; 
$glue	  = ( !empty($_POST['glue']) ) ? $_POST['glue'] : ''; 
$action   = ( !empty($_POST['action']) ) ? $_POST['action'] : 'download'; 
$compress = ( !empty($_POST['compress']) ) ? $_POST['compress'] : 'none'; 

$file_local	 = ( !empty($_POST['file_local']) ) ? trim($_POST['file_local']) : ''; 
$file_upload = ( !empty($_FILES['file_upload']) ) ? $_FILES['file_upload'] : array(); 

switch( $mode )
{
	case 'export':
		$auth_type = AUTH_EXPORT; 
		break;
	
	case 'import':
		$auth_type = AUTH_IMPORT; 
		break;
	
	case 'ban':
		$auth_type = AUTH_BAN; 
		break;
	
	case 'backup':
	case 'restore':
		if( !ereg(DATABASE, '^mysql') )
		{
			trigger_error('Database_unsupported', MESSAGE); 
		}
	case 'attach':
		if( $admindata['admin_level'] != ADMIN )
		{
			$meta = '<meta http-equiv="Refresh" content="4;url=' . sessid('tools.php') . '">'; 
			
			$message  = $lang['Message']['Not_authorized']; 
			$message .= '<br /><br />' . sprintf($lang['Click_return_index'], '<a href="' . sessid('index.php') . '">', '</a>'); 
			trigger_error($message, MESSAGE); 
		}
	
	case 'generator':
		$auth_type = AUTH_VIEW; 
		break;
	
	default:
		$mode = ''; 
		$auth_type = AUTH_VIEW; 
		break;
}

$url_page  = 'tools.php'; 
$url_page .= ( $mode != '' ) ? '?mode=' . $mode : ''; 

if( $mode != 'backup' && $mode != 'restore' && !$admindata['session_liste'] )
{
	$liste_id_ary = $auth->check_auth($auth_type); 
	
	if( !count($liste_id_ary) )
	{
		trigger_error('Not_' . $auth->auth_ary[$auth_type], MESSAGE); 
	}
	
	include('./page_header.php'); 
	
	$template->set_filenames(array(
		'body' => 'select_liste_body.tpl'
	)); 
	
	$template->assign_vars(array(
		'L_TITLE' => $lang['Title']['select'],
		'L_SELECT_LISTE' => $lang['Choice_liste'],
		'L_VALID_BUTTON' => $lang['Button']['valid'],
		
		'LISTE_BOX' => build_listbox('return', $auth_type),		
		'S_HIDDEN_FIELDS' => '<input type="hidden" name="sessid" value="' . $session->session_id . '" />',
		'U_FORM' => sessid($url_page)
	)); 
	
	$template->pparse('body'); 
	
	include('./page_footer.php'); 
}
else if( $admindata['session_liste'] )
{
	$listdata = $auth->listdata[$admindata['session_liste']]; 
}

if( !$auth->check_auth($auth_type, $admindata['session_liste']) )
{
	trigger_error('Not_' . $auth->auth_ary[$auth_type], MESSAGE); 
}

if( !isset($_POST['submit']) )
{
	if( $mode != 'backup' && $mode != 'restore' )
	{
		build_listbox('display', $auth_type, $url_page); 
	}
	
	$tools_ary = array('export', 'import', 'ban', 'generator'); 
	
	if( $admindata['admin_level'] == ADMIN )
	{
		$tools_ary[] = 'attach'; 
		$tools_ary[] = 'backup'; 
		$tools_ary[] = 'restore'; 
	}
	
	$tools_box = '<select name="mode">'; 
	foreach( $tools_ary AS $tool_name )
	{
		$selected = ( $mode == $tool_name ) ? ' selected="selected"' : ''; 
		$tools_box .= '<option value="' . $tool_name . '"' . $selected . '> - ' . $lang['Title'][$tool_name] . ' - </option>'; 
	}
	$tools_box .= '</select>'; 
	
	include('./page_header.php'); 
	
	$template->set_filenames(array(
		'body' => 'tools_body.tpl'
	)); 
	
	$template->assign_vars(array(
		'L_TITLE' => $lang['Title']['tools'],
		'L_EXPLAIN' => nl2br($lang['Explain']['tools']),
		'L_SELECT_TOOL' => $lang['Select_tool'],
		'L_VALID_BUTTON' => $lang['Button']['valid'],
		
		'S_TOOLS_BOX' => $tools_box,
		'S_HIDDEN_FIELDS' => ( $session->sessid_url != '' ) ? '<inpit type="hidden" name="sessid" value="' . $session->session_id . '" />' : ''
	)); 
}

$zip_loaded  = false; 
$zlib_loaded = false; 
$bz2_loaded	 = false; 

if( WA_PHP_VERSION >= 40100 && @extension_loaded('zip') )
{
	$zip_loaded = true; 
}

if( @extension_loaded('zlib') )
{
	$zlib_loaded = true; 
}

if( @extension_loaded('bz2') )
{
	$bz2_loaded = true; 
}

$upload_on = false; 

$file_uploads_value = @ini_get('file_uploads'); 
if( $file_uploads_value && strtolower($file_uploads_value) != 'off' )
{
	$upload_on = true; 
}

//
// On augmente le temps d'excution du script 
// Certains hbergeurs empchent pour des raisons videntes cette possibilit
// Si c'est votre cas, vous tes mal barr 
//
@set_time_limit(1200); 


switch( $mode )
{
	case 'export':
		if( isset($_POST['submit']) )
		{
			$glue = ( $glue != '' ) ? $glue : "\r\n"; 
			
			$sql_where = ''; 
			if( $listdata['liste_format'] == FORMAT_MULTIPLE )
			{
				$sql_where = ' AND al.format = ' . $format; 
			}
			
			$sql = "SELECT a.abo_email 
					FROM " . ABONNES_TABLE . " AS a, " . ABO_LISTE_TABLE . " AS al 
					WHERE al.liste_id = " . $admindata['session_liste'] . " AND a.abo_id = al.abo_id 
					  AND a.abo_status = " . ABO_ACTIF . $sql_where; 
			if( !($result = $db->query($sql)) )
			{
				trigger_error('Impossible d\'obtenir la liste des emails  exporter', ERROR); 
			}
			
			$contents = ''; 
			while( $row = $db->fetch_array($result) )
			{
				$contents .= ( $contents != '' ) ? $glue : ''; 
				$contents .= $row['abo_email']; 
			}
			$db->free_result($result); 
			
			$filename	= 'wa_export_' . $admindata['session_liste'] . '.txt'; 
			$mime_type	= ''; 
			
			//
			// Prparation des donnes selon l'option demande 
			//
			$contents = compress_filedata($filename, $mime_type, $contents, $compress); 
			
			if( $action == 'download' )
			{
				include($waroot . 'includes/class.attach.php'); 
				
				Attach::send_file($filename, $mime_type, $contents); 
			}
			else
			{
				if( !($fw = @fopen($filename, 'wb')) )
				{
					trigger_error('Impossible d\'crire le fichier de sauvegarde', ERROR); 
				}
				
				@fwrite($fw, $contents); 
				@fclose($fw); 
				
				trigger_error('Success_export', MESSAGE); 
			}
		}
		
		$template->set_filenames(array(
			'tool_body' => 'export_body.tpl'
		)); 
		
		$template->assign_vars(array(
			'L_TITLE_EXPORT' => $lang['Title']['export'],
			'L_EXPLAIN_EXPORT' => nl2br($lang['Explain']['export']),
			'L_GLUE' => $lang['Char_glue'],
			'L_ACTION' => $lang['File_action'],
			'L_DOWNLOAD' => $lang['Download_action'],
			'L_STORE_ON_SERVER' => $lang['Store_action'],
			'L_VALID_BUTTON' => $lang['Button']['valid'],
			'L_RESET_BUTTON' => $lang['Button']['reset'],
			
			'S_HIDDEN_FIELDS' => '<input type="hidden" name="sessid" value="' . $session->session_id . '" />'
		)); 
		
		if( $zlib_loaded || $bz2_loaded )
		{
			$template->assign_block_vars('compress_option', array(
				'L_COMPRESS' => $lang['Compress'],
				'L_NO' => $lang['No']
			)); 
			
			if( $zlib_loaded )
			{
				$template->assign_block_vars('compress_option.gzip_compress', array()); 
			}
			
			if( $bz2_loaded )
			{
				$template->assign_block_vars('compress_option.bz2_compress', array()); 
			}
		}
		
		if( $listdata['liste_format'] == FORMAT_MULTIPLE )
		{
			include($waroot . 'includes/functions.box.php'); 
			
			$template->assign_block_vars('format_box', array(
				'L_FORMAT' => $lang['Format_to_export'],
				'FORMAT_BOX' => format_box('format')
			));
		}
		
		$template->assign_var_from_handle('TOOL_BODY', 'tool_body'); 
		break;
	
	case 'import':
		if( isset($_POST['submit']) )
		{
			$list_email = ( !empty($_POST['list_email']) ) ? trim($_POST['list_email']) : ''; 
			$list_tmp	= ''; 
			
			//
			// Import via upload ou fichier local ? 
			//
			if( !empty($file_local) || !empty($file_upload['name']) )
			{
				$unlink = false; 
				
				if( !empty($file_local) )
				{
					$tmp_filename = wa_realpath($waroot . str_replace('\\\\', '/', $file_local)); 
					$filename	  = $file_local; 
					
					if( !@file_exists($tmp_filename) )
					{
						$meta = '<meta http-equiv="Refresh" content="5;url=' . sessid('tools.php?mode=import') . '">'; 
						
						$message  = sprintf($lang['Message']['Error_local'], htmlentities($filename)); 
						$message .= '<br /><br />' . sprintf($lang['Click_return_back'], '<a href="' . sessid('tools.php?mode=import') . '">', '</a>'); 
						trigger_error($message, MESSAGE); 
					}
				}
				else
				{
					$tmp_filename = $file_upload['tmp_name']; 
					$filename	  = $file_upload['name']; 
					
					if( !@is_uploaded_file($tmp_filename) )
					{
						trigger_error('Upload_error_5', MESSAGE); 
					}
					
					$open_basedir = @ini_get('open_basedir'); 					
					if( !empty($open_basedir) )
					{
						$tmp_filename = $waroot . $nl_config['upload_path'] . 'tmp/' . $filename; 
						move_uploaded_file($file_upload['tmp_name'], $tmp_filename); 
						$unlink = true; 
					}
				}
				
				if( !preg_match('/\.(txt|gz|bz2)$/i', $filename, $match) )
				{
					trigger_error('Bad_file_type', MESSAGE); 
				}
				
				$file_ext = $match[1]; 
				
				if( ( !$zlib_loaded && $file_ext == 'gz' ) || ( !$bz2_loaded && $file_ext == 'bz2' ) )
				{
					trigger_error('Compress_unsupported', MESSAGE); 
				}
				
				$list_tmp = decompress_filedata($tmp_filename, $file_ext); 
				
				$list_tmp = addslashes($list_tmp); 
				
				if( $unlink )
				{
					include($waroot . 'includes/class.attach.php'); 
					
					Attach::remove_file($tmp_filename); 
				}
			}
			
			//
			// Mode importation via le textarea 
			//
			else if( strlen($list_email) > 5 )
			{
				$list_tmp = $list_email; 
			}
			
			// 
			// Aucun fichier d'import reu et textarea vide 
			//
			else
			{
				$meta = '<meta http-equiv="Refresh" content="5;url=' . sessid('tools.php?mode=import') . '">'; 
				
				$message  = $lang['Message']['No_data_received']; 
				$message .= '<br /><br />' . sprintf($lang['Click_return_back'], '<a href="' . sessid('tools.php?mode=import') . '">', '</a>'); 
				trigger_error($message, MESSAGE); 
			}
			
			include($waroot . 'includes/functions.validate.php'); 
			
			$glue = ( $glue != '' ) ? $glue : "\n"; 
			$emails_ok = $emails_bad = array(); 
			
			if( $listdata['liste_format'] != FORMAT_MULTIPLE )
			{
				$format = $listdata['liste_format']; 
			}
			
			$emails_ary = explode($glue, $list_tmp); 
			
			$num_emails = ( count($emails_ary) > MAX_IMPORT ) ? MAX_IMPORT : count($emails_ary); 
			
			for( $i = 0; $i < $num_emails; $i++ )
			{
				$email = trim($emails_ary[$i]); 
				
				$resultat = check_email($email, $admindata['session_liste'], 'inscription'); 
				
				if( $resultat['error'] )
				{
					$emails_bad[$email] = $resultat['message']; 
				}
				else
				{
					$abo_id = ( !empty($resultat['abo_data']['abo_id']) ) ? $resultat['abo_data']['abo_id'] : false; 
					
					$emails_ok[$email] = $abo_id; 
				}
			}
			
			$current_time = time(); 
			
			foreach( $emails_ok AS $email => $abo_id )
			{
				$db->transaction(START_TRC); 
				
				if( !$abo_id )
				{
					$sql = "INSERT INTO " . ABONNES_TABLE . " (abo_email, abo_register_key, abo_register_date, abo_status) 
							VALUES('$email', '" . generate_key() . "', $current_time, " . ABO_ACTIF . ")"; 
					if( !$db->query($sql) )
					{
						trigger_error('Impossible d\'insrer une nouvelle entre dans la table des abonns', ERROR); 
					}
					
					$abo_id = $db->next_id(); 
				}
				
				$sql = "INSERT INTO " . ABO_LISTE_TABLE . " (abo_id, liste_id, format) 
						VALUES($abo_id, " . $admindata['session_liste'] . ", $format)"; 
				if( !$db->query($sql) )
				{
					trigger_error('Impossible d\'insrer une nouvelle entre dans la table abo_liste', ERROR); 
				}
				
				$db->transaction(END_TRC); 
			}
			
			// TODO : Renvoyer fichier avec emails refuss
			
			trigger_error('Success_import', MESSAGE); 
		}
		
		$template->set_filenames(array(
			'tool_body' => 'import_body.tpl'
		)); 
		
		$template->assign_vars(array(
			'L_TITLE_IMPORT' => $lang['Title']['import'],
			'L_EXPLAIN_IMPORT' => nl2br(sprintf($lang['Explain']['import'], MAX_IMPORT)),
			'L_GLUE' => $lang['Char_glue'],
			'L_FILE_LOCAL' => $lang['File_local'],
			'L_VALID_BUTTON' => $lang['Button']['valid'],
			'L_RESET_BUTTON' => $lang['Button']['reset'],
			
			'S_HIDDEN_FIELDS' => '<input type="hidden" name="sessid" value="' . $session->session_id . '" />',
			'S_ENCTYPE' => ( $upload_on ) ? 'enctype="multipart/form-data"' : ''
		)); 
		
		if( $listdata['liste_format'] == FORMAT_MULTIPLE )
		{
			include($waroot . 'includes/functions.box.php'); 
			
			$template->assign_block_vars('format_box', array(
				'L_FORMAT' => $lang['Format_to_import'],
				'FORMAT_BOX' => format_box('format')
			));
		}
		
		if( $upload_on )
		{
			//
			// L'upload est disponible sur le serveur
			// Affichage du champ file pour importation
			//
			$template->assign_block_vars('upload_file', array(
				'L_FILE_UPLOAD' => $lang['File_upload']
			));
		}
		
		$template->assign_var_from_handle('TOOL_BODY', 'tool_body'); 
		break;
	
	case 'ban':
		if( isset($_POST['submit']) )
		{
			$pattern 	   = ( !empty($_POST['pattern']) ) ? trim($_POST['pattern']) : ''; 
			$unban_list_id = ( !empty($_POST['unban_list_id']) ) ? $_POST['unban_list_id'] : array(); 
			
			if( $pattern != '' )
			{
				$pattern_ary = explode(',', $pattern); 
				
				foreach( $pattern_ary AS $pattern )
				{
					$pattern = trim($pattern); 
					
					$sql = "INSERT INTO " . BANLIST_TABLE . " (liste_id, ban_email) 
							VALUES(" . $admindata['session_liste'] . ", '$pattern')"; 
					if( !$db->query($sql) )
					{
						trigger_error('Impossible de mettre  jour la table des bannis', ERROR); 
					}
				}
			}
			
			$sql_list_id = ''; 
			for( $i = 0; $i < count($unban_list_id); $i++ )
			{
				if( $unban_list_id[$i] > 0 )
				{
					$sql_list_id .= ( ( $sql_list_id != '' ) ? ', ' : '' ) . $unban_list_id[$i]; 
				}
			}
			
			if( $sql_list_id != '' )
			{
				$sql = "DELETE FROM " . BANLIST_TABLE . " WHERE ban_id IN ($sql_list_id)"; 
				if( !$db->query($sql) )
				{
					trigger_error('Impossible de supprimer les emails bannis slectionns', ERROR); 
				}
			}
			
			$meta = '<meta http-equiv="Refresh" content="4;url=' . sessid('tools.php?mode=ban') . '">'; 
			
			$message  = $lang['Message']['Success_modif']; 
			$message .= '<br /><br />' . sprintf($lang['Click_return_back'], '<a href="' . sessid('tools.php?mode=ban') . '">', '</a>'); 
			$message .= '<br /><br />' . sprintf($lang['Click_return_index'], '<a href="' . sessid('index.php') . '">', '</a>'); 
			trigger_error($message, MESSAGE); 
		}
		
		$sql = "SELECT ban_id, ban_email 
				FROM " . BANLIST_TABLE . " 
				WHERE liste_id = " . $admindata['session_liste']; 
		if( !($result = $db->query($sql)) )
		{
			trigger_error('Impossible d\'obtenir la liste des masques de bannissement', ERROR); 
		}
		
		$unban_email_box = '<select name="unban_list_id[]" multiple="multiple" size="10">'; 
		if( $row = $db->fetch_array($result) )
		{
			do
			{		
				$unban_email_box .= '<option value="' . $row['ban_id'] . '"> - ' . $row['ban_email'] . ' - </option>'; 
			}
			while( $row = $db->fetch_array($result) ); 	
		}
		else
		{
			$unban_email_box .= '<option value="0"> - ' . $lang['No_email_banned'] . ' - </option>'; 
		}
		$unban_email_box .= '</select>'; 
		
		$template->set_filenames( array(
			'tool_body' => 'ban_list_body.tpl'
		)); 
		
		$template->assign_vars(array(
			'L_TITLE_BAN' => $lang['Title']['ban'],
			'L_EXPLAIN_BAN' => nl2br($lang['Explain']['ban']),
			'L_EXPLAIN_UNBAN' => nl2br($lang['Explain']['unban']),
			'L_BAN_EMAIL' => $lang['Ban_email'],
			'L_UNBAN_EMAIL' => $lang['Unban_email'],
			'L_VALID_BUTTON' => $lang['Button']['valid'],
			'L_RESET_BUTTON' => $lang['Button']['reset'],
			
			'UNBAN_EMAIL_BOX' => $unban_email_box,
			'S_HIDDEN_FIELDS' => '<input type="hidden" name="sessid" value="' . $session->session_id . '" />'
		)); 
		
		$template->assign_var_from_handle('TOOL_BODY', 'tool_body'); 
		break;
	
	case 'attach':
		if( isset($_POST['submit']) )
		{
			$ext_list 	 = ( !empty($_POST['ext_list']) ) ? trim($_POST['ext_list']) : ''; 
			$ext_list_id = ( !empty($_POST['ext_list_id']) ) ? $_POST['ext_list_id'] : array(); 
			
			if( $ext_list != '' )
			{
				$ext_ary = explode(',', $ext_list); 
				
				foreach( $ext_ary AS $ext )
				{
					$ext = strtolower(trim($ext)); 
					
					if( preg_match('/^[\w_-]+$/', $ext) )
					{
						$sql = "INSERT INTO " . FORBIDDEN_EXT_TABLE . " (liste_id, fe_ext) 
							VALUES(" . $admindata['session_liste'] . ", '$ext')"; 
						if( !$db->query($sql) )
						{
							trigger_error('Impossible de mettre  jour la table des extensions interdites', ERROR); 
						}
					}
				}
			}
			
			$sql_list_id = ''; 
			for( $i = 0; $i < count($ext_list_id); $i++ )
			{
				if( $ext_list_id[$i] > 0 )
				{
					$sql_list_id .= ( ( $sql_list_id != '' ) ? ', ' : '' ) . $ext_list_id[$i]; 
				}
			}
			
			if( $sql_list_id != '' )
			{
				$sql = "DELETE FROM " . FORBIDDEN_EXT_TABLE . " WHERE fe_id IN ($sql_list_id)"; 
				if( !$db->query($sql) )
				{
					trigger_error('Impossible de supprimer les extensions interdites slectionnes', ERROR); 
				}
			}
			
			$meta = '<meta http-equiv="Refresh" content="4;url=' . sessid('tools.php?mode=attach') . '">'; 
			
			$message  = $lang['Message']['Success_modif']; 
			$message .= '<br /><br />' . sprintf($lang['Click_return_back'], '<a href="' . sessid('tools.php?mode=attach') . '">', '</a>'); 
			$message .= '<br /><br />' . sprintf($lang['Click_return_index'], '<a href="' . sessid('index.php') . '">', '</a>'); 
			trigger_error($message, MESSAGE); 
		}
		
		$sql = "SELECT fe_id, fe_ext 
				FROM " . FORBIDDEN_EXT_TABLE . " 
				WHERE liste_id = " . $admindata['session_liste']; 
		if( !($result = $db->query($sql)) )
		{
			trigger_error('Impossible d\'obtenir la liste des extensions interdites', ERROR); 
		}
		
		$reallow_ext_box = '<select name="ext_list_id[]" multiple="multiple" size="10">'; 
		if( $row = $db->fetch_array($result) )
		{
			do
			{		
				$reallow_ext_box .= '<option value="' . $row['fe_id'] . '"> - ' . $row['fe_ext'] . ' - </option>'; 
			}
			while( $row = $db->fetch_array($result) ); 	
		}
		else
		{
			$reallow_ext_box .= '<option value="0"> - ' . $lang['No_forbidden_ext'] . ' - </option>'; 
		}
		$reallow_ext_box .= '</select>'; 
		
		$template->set_filenames( array(
			'tool_body' => 'forbidden_ext_body.tpl'
		)); 
		
		$template->assign_vars(array(
			'L_TITLE_EXT' => $lang['Title']['attach'],
			'L_EXPLAIN_TO_FORBID' => nl2br($lang['Explain']['forbid_ext']),
			'L_EXPLAIN_TO_REALLOW' => nl2br($lang['Explain']['reallow_ext']),
			'L_FORBID_EXT' => $lang['Forbid_ext'],
			'L_REALLOW_EXT' => $lang['Reallow_ext'],
			'L_VALID_BUTTON' => $lang['Button']['valid'],
			'L_RESET_BUTTON' => $lang['Button']['reset'],
			
			'REALLOW_EXT_BOX' => $reallow_ext_box,
			'S_HIDDEN_FIELDS' => '<input type="hidden" name="sessid" value="' . $session->session_id . '" />'
		)); 
		
		$template->assign_var_from_handle('TOOL_BODY', 'tool_body'); 
		break;
	
	case 'backup':
		$tables_wa = array(
			ABO_LISTE_TABLE, ABONNES_TABLE, ADMIN_TABLE, AUTH_ADMIN_TABLE, BANLIST_TABLE, CONFIG_TABLE, 
			JOINED_FILES_TABLE, FORBIDDEN_EXT_TABLE, LISTE_TABLE, LOG_TABLE, LOG_FILES_TABLE, SESSIONS_TABLE
		); 
		
		$tables_plus = ( !empty($_POST['tables_plus']) ) ? wa_array_map('trim', $_POST['tables_plus']) : array(); 
		$backup_type = ( isset($_POST['backup_type']) ) ? intval($_POST['backup_type']) : 0; 		
		$drop_option = ( !empty($_POST['drop_option']) ) ? true : false; 
		
		if( !($result = $db->query('SHOW TABLE STATUS FROM ' . $dbname)) )
		{
			trigger_error('Impossible d\'obtenir la liste des tables', ERROR); 
		}
		
		while( $row = $db->fetch_row($result) )
		{
			if( !isset($_POST['submit']) )
			{
				if( !in_array($row[0], $tables_wa) )
				{
					$tables_plus[] = $row[0]; 
				}
			}
			else
			{
				if( in_array($row[0], $tables_wa) || in_array($row[0], $tables_plus) )
				{
					$tables[] = array('name' => $row[0], 'type' => $row[1]); 
				}
			}			
		}
		$db->free_result($result); 
		
		if( isset($_POST['submit']) )
		{
			//
			// Lancement de la sauvegarde. Pour commencer, l'entte du fichier sql 
			//
			$contents  = "#\n"; 
			$contents .= "# WAnewsletter " . $nl_config['version'] . " Backup\n"; 
			$contents .= "# Database : $dbname\n"; 
			$contents .= "#\n"; 
			$contents .= "# Date : " . date('d/m/Y H:i:s') . "\n"; 
			$contents .= "#\n\n"; 
			
			foreach( $tables AS $table_data )
			{
				if( $backup_type != 2 )
				{
					$contents .= "#\n"; 
					$contents .= "# Struture de la table " . $table_data['name'] . "\n"; 
					$contents .= "#\n"; 
					
					$contents .= get_table_structure($table_data['name'], $table_data['type'], $drop_option); 					
				}
				
				if( $backup_type != 1 )
				{
					$sql = 'SELECT * FROM ' . $table_data['name']; 
					if( !($result = $db->query($sql)) )
					{
						trigger_error('Impossible d\'obtenir le contenu de la table ' . $table_data['name'], ERROR); 
					}
					
					$num_rows = $db->num_rows($result); 
					
					$contents .= "\n#\n"; 
					$contents .= "# Contenu de la table " . $table_data['name'] . "\n"; 
					$contents .= "# $num_rows enregistrement(s)\n"; 
					$contents .= "#\n"; 
					
					$fields = array(); 
					$num_fields = $db->num_fields($result); 
					for( $j = 0; $j < $num_fields; $j++ )
					{
						$fields[] = $db->field_name($j, $result); 
					}
					
					$columns_list = implode(', ', $fields); 
					
					while( $row = $db->fetch_row($result) )
					{
						$contents .= "INSERT INTO " . $table_data['name'] . " ($columns_list) VALUES"; 
						
						foreach( $row AS $key => $value )
						{
							if( !isset($value) )
							{
								$row[$key] = 'NULL'; 
							}
							else if( !is_numeric($value) )
							{
								$row[$key] = '\'' . addslashes($value) . '\''; 
							}
						}
						
						$contents .= '(' . implode(', ', $row) . ");\n"; 
					}
					$db->free_result($result); 
				}
				
				$contents .= "\n\n"; 
			}
			
			$filename	= 'wanewsletter_backup.sql'; 
			$mime_type	= ''; 
			
			//
			// Prparation des donnes selon l'option demande 
			//
			$contents = compress_filedata($filename, $mime_type, $contents, $compress); 
			
			if( $action == 'download' )
			{
				include($waroot . 'includes/class.attach.php'); 
				
				Attach::send_file($filename, $mime_type, $contents); 				
			}
			else
			{
				if( !($fw = @fopen($filename, 'wb')) )
				{
					trigger_error('Impossible d\'crire le fichier de sauvegarde', ERROR); 
				}
				
				@fwrite($fw, $contents); 
				@fclose($fw); 
				
				trigger_error('Success_backup', MESSAGE); 
			}
		}
		
		$tables_box = ''; 
		if( count($tables_plus) )
		{
			$tables_box = '<select name="tables_plus[]" multiple="multiple" size="6">'; 
			
			foreach( $tables_plus AS $table_name )
			{
				$tables_box .= '<option value="' . $table_name . '"> - ' . $table_name . ' - </option>'; 
			}
			
			$tables_box .= '</select>'; 
		}
		
		$template->set_filenames(array(
			'tool_body' => 'backup_body.tpl'
		)); 
		
		$template->assign_vars(array(
			'L_TITLE_BACKUP' => $lang['Title']['backup'],
			'L_EXPLAIN_BACKUP' => nl2br($lang['Explain']['backup']),
			'L_BACKUP_TYPE' => $lang['Backup_type'],
			'L_FULL' => $lang['Backup_full'],
			'L_STRUCTURE' => $lang['Backup_structure'],
			'L_DATA' => $lang['Backup_data'],
			'L_DROP_OPTION' => $lang['Drop_option'],
			'L_ACTION' => $lang['File_action'],
			'L_DOWNLOAD' => $lang['Download_action'],
			'L_STORE_ON_SERVER' => $lang['Store_action'],
			'L_YES' => $lang['Yes'],
			'L_NO' => $lang['No'],
			'L_VALID_BUTTON' => $lang['Button']['valid'],
			'L_RESET_BUTTON' => $lang['Button']['reset'],
			
			'S_HIDDEN_FIELDS' => '<input type="hidden" name="sessid" value="' . $session->session_id . '" />'
		)); 
		
		if( $tables_box != '' )
		{
			$template->assign_block_vars('tables_box', array(
				'L_ADDITIONAL_TABLES' => $lang['Additionnal_tables'],
				'S_TABLES_BOX' => $tables_box
			)); 
		}
		
		if( $zlib_loaded || $bz2_loaded )
		{
			$template->assign_block_vars('compress_option', array(
				'L_COMPRESS' => $lang['Compress']
			)); 
			
			if( $zlib_loaded )
			{
				$template->assign_block_vars('compress_option.gzip_compress', array()); 
			}
			
			if( $bz2_loaded )
			{
				$template->assign_block_vars('compress_option.bz2_compress', array()); 
			}
		}
		
		$template->assign_var_from_handle('TOOL_BODY', 'tool_body'); 
		break;
	
	case 'restore':
		if( isset($_POST['submit']) )
		{
			$data = ''; 
			
			//
			// Import via upload ou fichier local ? 
			//
			if( !empty($file_local) || !empty($file_upload['name']) )
			{
				$unlink = false; 
				
				if( !empty($file_local) )
				{
					$tmp_filename = wa_realpath($waroot . str_replace('\\\\', '/', $file_local)); 
					$filename	  = $file_local; 
					
					if( !@file_exists($tmp_filename) )
					{
						$meta = '<meta http-equiv="Refresh" content="5;url=' . sessid('tools.php?mode=restore') . '">'; 
						
						$message  = sprintf($lang['Message']['Error_local'], htmlspecialchars($filename)); 
						$message .= '<br /><br />' . sprintf($lang['Click_return_back'], '<a href="' . sessid('tools.php?mode=restore') . '">', '</a>'); 
						trigger_error($message, MESSAGE); 
					}
				}
				else
				{
					$tmp_filename = $file_upload['tmp_name']; 
					$filename	  = $file_upload['name']; 
					
					if( !@is_uploaded_file($tmp_filename) )
					{
						trigger_error('Upload_error_5', MESSAGE); 
					}
					
					$open_basedir = @ini_get('open_basedir'); 					
					if( !empty($open_basedir) )
					{
						$tmp_filename = $waroot . $nl_config['upload_path'] . 'tmp/' . $filename; 
						move_uploaded_file($file_upload['tmp_name'], $tmp_filename); 
						$unlink = true; 
					}
				}
				
				if( !preg_match('/\.(txt|gz|bz2)$/i', $filename, $match) )
				{
					trigger_error('Bad_file_type', MESSAGE); 
				}
				
				$file_ext = $match[1]; 
				
				if( ( !$zlib_loaded && $file_ext == 'gz' ) || ( !$bz2_loaded && $file_ext == 'bz2' ) )
				{
					trigger_error('Compress_unsupported', MESSAGE); 
				}
				
				$data = decompress_filedata($tmp_filename, $file_ext); 
				
				if( $unlink )
				{
					include($waroot . 'includes/class.attach.php'); 
					
					Attach::remove_file($tmp_filename); 
				}
			}
			
			// 
			// Aucun fichier de restauration reu 
			//
			else
			{
				$meta = '<meta http-equiv="Refresh" content="5;url=' . sessid('tools.php?mode=restore') . '">'; 
				
				$message  = $lang['Message']['No_data_received']; 
				$message .= '<br /><br />' . sprintf($lang['Click_return_back'], '<a href="' . sessid('tools.php?mode=restore') . '">', '</a>'); 
				trigger_error($message, MESSAGE); 
			}
			
			$queries = make_sql_ary($data); 
			
			foreach( $queries AS $query )
			{
				$db->query($query); 
			}
			
			trigger_error('Success_restore', MESSAGE); 
		}
		
		$template->set_filenames(array(
			'tool_body' => 'restore_body.tpl'
		)); 
		
		$template->assign_vars(array(
			'L_TITLE_RESTORE' => $lang['Title']['restore'],
			'L_EXPLAIN_RESTORE' => nl2br($lang['Explain']['restore']),
			'L_FILE_LOCAL' => $lang['File_local'],
			'L_VALID_BUTTON' => $lang['Button']['valid'],
			'L_RESET_BUTTON' => $lang['Button']['reset'],
			
			'S_HIDDEN_FIELDS' => '<input type="hidden" name="sessid" value="' . $session->session_id . '" />',
			'S_ENCTYPE' => ( $upload_on ) ? 'enctype="multipart/form-data"' : ''
		)); 
		
		if( $upload_on )
		{
			//
			// L'upload est disponible sur le serveur
			// Affichage du champ file pour importation
			//
			$template->assign_block_vars('upload_file', array(
				'L_FILE_UPLOAD' => $lang['File_upload_restore']
			));
		}
		
		$template->assign_var_from_handle('TOOL_BODY', 'tool_body'); 
		break;
	
	case 'generator':
		if( isset($_POST['generate']) )
		{
			$url_form = !empty($_POST['url_form']) ? trim($_POST['url_form']) : '' ; 
			
			$code_html  = "<form method=\"post\" action=\"" . htmlspecialchars($url_form) . "\">\n";
			$code_html .= $lang['Email_address'] . " : <input type=\"text\" name=\"email\" maxlength=\"100\" /> &amp;nbsp; \n";
			
			if( $listdata['liste_format'] == FORMAT_MULTIPLE )
			{
				$code_html .= $lang['Format'] . " : <select name=\"format\">\n"; 
				$code_html .= "<option value=\"" . FORMAT_TEXTE . "\">TXT</option>\n"; 
				$code_html .= "<option value=\"" . FORMAT_HTML . "\">HTML</option>\n"; 
				$code_html .= "</select>\n"; 
			}
			else
			{
				$code_html .= "<input type=\"hidden\" name=\"format\" value=\"" . $listdata['liste_format'] . "\" />\n";
			}
			
			$code_html .= "<input type=\"hidden\" name=\"liste\" value=\"" . $admindata['session_liste'] . "\" />\n";
			$code_html .= "<br />\n"; 
			
			$code_html .= "<input type=\"radio\" name=\"action\" value=\"inscription\" checked=\"checked\" /> " . $lang['Subscribe'] . " <br />\n";
			$code_html .= ( $listdata['liste_format'] == FORMAT_MULTIPLE ) ? "<input type=\"radio\" name=\"action\" value=\"setformat\" /> " . $lang['Setformat'] . " <br />\n" : "";
			$code_html .= "<input type=\"radio\" name=\"action\" value=\"desinscription\" /> " . $lang['Unsubscribe'] . " <br />\n";
			$code_html .= "<input type=\"submit\" name=\"wanewsletter\" value=\"" . $lang['Button']['valid'] . "\" />\n";
			$code_html .= "</form>"; 
			
			$code_php  = "<?php\n"; 
			$code_php .= "define('IN_WA_FORM', true);\n"; 
			$code_php .= "\$wapath = '" . wa_realpath($waroot . 'newsletter.php') . "';\n"; 
			$code_php .= "\$waroot = substr(\$wapath, 0, (strrpos(\$wapath, '/')+1));\n"; 
			$code_php .= "include(\$wapath);\n"; 
			$code_php .= "?>"; 
			
			$template->set_filenames(array(
				'tool_body' => 'result_generator_body.tpl'
			)); 
			
			$template->assign_vars( array(
				'L_TITLE_GENERATOR' => $lang['Title']['generator'],
				'L_EXPLAIN_CODE_HTML' => nl2br($lang['Explain']['code_html']),
				'L_EXPLAIN_CODE_PHP' => nl2br($lang['Explain']['code_php']),
				
				'CODE_HTML' => $code_html,
				'CODE_PHP' => $code_php
			)); 
		}
		else
		{
			$template->set_filenames(array(
				'tool_body' => 'generator_body.tpl'
			)); 
			
			$template->assign_vars(array(
				'L_TITLE_GENERATOR' => $lang['Title']['generator'],
				'L_EXPLAIN_GENERATOR' => nl2br($lang['Explain']['generator']),
				'L_TARGET_FORM' => $lang['Target_form'],
				'L_VALID_BUTTON' => $lang['Button']['valid'],
				
				'S_HIDDEN_FIELDS' => '<input type="hidden" name="sessid" value="' . $session->session_id . '" />'
			)); 
		}
		
		$template->assign_var_from_handle('TOOL_BODY', 'tool_body'); 
		break;
}

$template->pparse('body'); 

include('./page_footer.php'); 
?>