<?php
/*******************************************************************
 *			
 * 			Fichier			:	class.auth.php 
 * 			Cr le			:	21 janvier 2003 
 * 			Dernire modif	:	16 avril 2003 
 * 			Email			:	wascripts@phpcodeur.net 
 * 
 * 				Copyright  2002-2003 phpCodeur
 * 
 *******************************************************************/

/*******************************************************************
 *  This program is free software; you can redistribute it and/or 
 * 	modify it under the terms of the GNU General Public License as 
 * 	published by the Free Software Foundation; either version 2 of 
 *  the License, or (at your option) any later version. 
 *******************************************************************/


if( !defined('CLASS_AUTH_INC') )
{

define('CLASS_AUTH_INC', 1); 

class Auth {
	
	var $listdata  = array(); 
	var $rowset    = array(); 
	
	var $auth_ary  = array(
			AUTH_VIEW 	=> 'auth_view', 
			AUTH_EDIT 	=> 'auth_edit', 
			AUTH_DEL  	=> 'auth_del', 
			AUTH_SEND 	=> 'auth_send', 
			AUTH_IMPORT => 'auth_import', 
			AUTH_EXPORT => 'auth_export', 
			AUTH_BAN 	=> 'auth_ban', 
			AUTH_ATTACH => 'auth_attach'
		); 
	
	function Auth()
	{
		global $db, $admindata; 
		
		$this->read_data($admindata['admin_id']); 
	}
	
	function read_data($admin_id)
	{
		global $db, $admindata; 
		
		$sql = "SELECT li.*, aa.auth_view, aa.auth_edit, aa.auth_del, aa.auth_send, 
					aa.auth_import, aa.auth_export, aa.auth_ban, aa.auth_attach 
				FROM " . LISTE_TABLE . " AS li 
				LEFT JOIN " . AUTH_ADMIN_TABLE . " AS aa ON aa.admin_id = " . $admin_id . " 
				 AND aa.liste_id = li.liste_id 
				ORDER BY li.liste_name ASC"; 
		if( !($result = $db->query($sql)) )
		{
			trigger_error('Impossible d\'obtenir les donnes des listes de diffusion', ERROR); 
		}
		
		$tmp_ary = array(); 
		while( $row = $db->fetch_array($result) )
		{
			$tmp_ary[$row['liste_id']] = $row; 
		}
		
		if( $admindata['admin_id'] != $admin_id )
		{
			return $tmp_ary; 
		}
		
		$this->listdata = $tmp_ary; 
	}
	
	function check_auth($auth_type, $liste_id = 0)
	{
		global $admindata; 
		
		$auth_name = $this->auth_ary[$auth_type]; 
		
		if( !$liste_id )
		{
			$liste_id_ary = array(); 
			foreach( $this->listdata AS $liste_id => $auth_list )
			{
				if( $admindata['admin_level'] == ADMIN || !empty($auth_list[$auth_name]) )
				{
					$liste_id_ary[] = $liste_id; 
				}
			}
			
			return $liste_id_ary; 
		}
		else
		{
			return ( $admindata['admin_level'] == ADMIN || !empty($this->listdata[$liste_id][$auth_name]) ) ? true : false; 
		}
	}
	
	function box_auth($auth_type, $listdata)
	{
		global $lang; 
		
		$auth_name = $this->auth_ary[$auth_type]; 
		
		$box_auth = "\n<select name=\"" . $auth_name . "[]\">\n"; 
		if( !empty($listdata[$auth_name]) )
		{
			$box_auth .= "<option value=\"1\" selected=\"selected\"> " . $lang['Yes'] . " </option>\n"; 
			$box_auth .= "<option value=\"0\"> " . $lang['No'] . " </option>\n"; 
		}
		else
		{
			$box_auth .= "<option value=\"1\"> " . $lang['Yes'] . " </option>\n"; 
			$box_auth .= "<option value=\"0\" selected=\"selected\"> " . $lang['No'] . " </option>\n"; 
		}
		$box_auth .= "</select>\n"; 
		
		return $box_auth; 
	}
}

}
?>