<?php
/*******************************************************************
 *			
 * 			Fichier         :	class.mailer.php 
 * 			Cr le         :	29 juin 2002 
 * 			Dernire modif  :	17 avril 2003 
 * 			Email           :	wascripts@phpcodeur.net 
 * 
 * 				Copyright  2002-2003 phpCodeur - WAmailer 2.0
 * 
 *******************************************************************/

/*******************************************************************
 *  This program is free software; you can redistribute it and/or 
 * 	modify it under the terms of the GNU General Public License as 
 * 	published by the Free Software Foundation; either version 2 of 
 *  the License, or (at your option) any later version. 
 *******************************************************************/


/*
 *  Classe d'envoi des emails.
 *  Fonctionne aussi chez online et nexen
 *  Gre l'attachement de pices jointes et l'envoi d'emails au format html
 *
 */
if( !defined('CLASS_MAILER_INC') )
{
define('CLASS_MAILER_INC', 1); 

define('WM_TPL_ALT', 1); 
define('WM_TPL_HTML', 2); 

define('WM_HOST_OTHER', 1); 
define('WM_HOST_ONLINE', 2); 
define('WM_HOST_NEXEN', 3); 

class Mailer {
	
	/*
     * Chemins par dfaut pour les modles d'emails 
     *
     * @var	string	$root_text
	 * @var string	$root_html
	 * 
	 * @access public
     */
	var $root_text		= './'; 
	var $root_html		= './'; 
	
	/*
     * Vous devez dfinir la fonction mail qu'utilise votre hbergeur 
	 * 
	 * 1 ou WM_HOST_OTHER pour la fonction mail() classique
	 * 2 ou WM_HOST_ONLINE pour la fonction email() de online
	 * 3 ou WM_HOST_NEXEN pour la fonction email() de nexen 
     *
     * @var	integer	$hebergeur
	 * 
	 * @access public
     */
	var $hebergeur 		= 1; 
	
	/*
     * Activation du mode smtp
	 * 
     * @var	booleen	$smtp_mode
	 * 
	 * @access public
     */
	var $smtp_mode 		= false; 
	
	/*
     * Remplissez le tableau pour indiquer au script les donnes qui lui permettront de se 
	 * connecter au serveur.
	 * 
     * @var	array	$smtp_data
	 * 	host -> nom ou ip du serveur smtp (ex: smtp.wanadoo.fr)
	 * 	port -> port utilis (en gnral 25)
	 * 	user -> login pour la connexion (seulement si ncessaire)
	 * 	pass -> password pour la connexion (seulement si ncessaire)
	 * 
	 * @access public
     */
	var $smtp_data		= array(
			'host' => '', 
			'port' => 25, 
			'user' => '', 
			'pass' => '' 
		);
	
	/*
     * Format de l'email 
	 * 
	 * 1 - pour format texte brut
	 * 2 - pour format html
	 * 3 - Double format (html affich, et texte si html pas support)
	 * 
     * @var	integer	$format
	 * 
	 * @access public
     */
	var $format			= 1; 
	
	/*
     * Variables diverses
	 * 
     * @var	string	$from_online
	 * @var	string	$reply_online
	 * @var	array	$from
	 * @var	array	$to
	 * @var	string	$subject
	 * @var	string	$message
	 * @var	string	$altmessage
	 * @var	array	$attachfile
	 * @var	string	$headers
	 * @var	string	$boundary_attach
	 * @var	string	$boundary_alt
	 * 
	 * @access private
     */
	var $from_online	= ''; 
	var $reply_online	= ''; 
	var $from 			= array('email' => '', 'name' => '');
	var $to 			= array('to'  => array(), 'cc'  => array(), 'bcc' => array()); 
	var $subject 		= '';
	var $message 		= '';
	var $altmessage 	= '';
	var $attachfile 	= array('path' => array(), 'name' => array(), 'disposition' => array(), 'mimetype' => array(), 'cid' => array());
	var $headers 		= array();
	
	var $boundary_attach = '';
	var $boundary_alt	= '';
	
	/*
     * Jeu de caractre 
	 * 
     * @var	string	$charset
	 * 
	 * @access public
     */	
	var $charset 		= 'iso-8859-1'; 
	
	/*
     * Encodage  utiliser 
	 * (7bit, 8bit, quoted-printable, base64 ou binary)
	 * 
     * @var	string	$encoding
	 * 
	 * @access public
     */
	var $encoding		= '8bit'; 
	
	/*
     * Nom du serveur metteur
	 * 
     * @var	string	$server
	 * 
	 * @access public
     */
	var $server			= 'localhost';	
	
	/*
     * Eventuels messages d'erreur
	 * 
     * @var	string	$mail_reponse
	 * 
	 * @access private
     */
	var $mail_reponse	= ''; // Variable contenant le message d'erreur en cas d'chec de l'envoi.
	
	/*
     * Activer/dsactiver le mode de dbogguage
	 * S'il est activ, les messages d'erreur s'afficheront directement  l'cran et l'xcution du script 
	 * sera interrompu
	 * 
     * @var	booleen	$debug
	 * 
	 * @access public
     */
	var $debug 			= false; 
	
	/*
     * Statut du traitement de l'envoi
	 * Cette variable ne doit pas tre modifie, si elle est  false, 
	 * l'email n'est tout simplement pas envoy
	 * 
     * @var	booleen	$statut
	 * 
	 * @access private
     */
	var $statut			= true; // ne pas modifier ! 
	
	/*
     * Version actuelle de la classe
	 * 
     * @var	string	$version
	 * 
	 * @access private
     */
	var $version		= '2.0'; 
	
	/*
	 * Mailer : Mailer()
	 * 
	 * @param string $path : Chemin vers les modles 
	 * 
	 * @access public
	 * 
	 * @return void
	 */
	function Mailer($path = '')
	{
		if( $path != '' )
		{
			$this->set_path_template($path); 
		}
	}
	
	/*
	 * Mailer : set_path_template()
	 * 
	 * @param string $path 		: Chemin vers les modles 
	 * @param string $tpl_type 	: Type des modles (texte ou html) 
	 * 
	 * @access public
	 * 
	 * @return boolean
	 */
	function set_path_template($path, $tpl_type = 0)
	{
		if( !is_dir($path) )
		{
			$this->error('set_path_template()', "Le chemin \"$path\" est incorrect."); 
			return false; 
		}
		
		$path = preg_replace('/^(.*)\/?$/', '\\1/', $path); 
		
		if( $tpl_type == WM_TPL_HTML )
		{
			$this->root_html = $path; 
		}
		else if( $tpl_type == WM_TPL_ALT )
		{
			$this->root_text = $path; 
		}
		else
		{
			$this->root_html = $this->root_text = $path; 
		}
		
		return true; 
	}
	
	/*
	 * Mailer : set_file()
	 * 
	 * @param string $path 	: Chemin vers le fichier
	 * 
	 * @access private
	 * 
	 * @return boolean
	 */
	function set_file($path)
	{
		if( !@file_exists($path) )
		{
			$this->error('set_file()', 'Le fichier "' . basename($path) . '" est introuvable'); 
			return false; 
		}
		else if( !@is_readable($path) )
		{
			$this->error('set_file()', 'Le fichier "' . basename($path) . '" n\'est pas accessible en lecture'); 
			return false; 
		}
		
		return true; 
	}
	
	/*
	 * Mailer : loadfile()
	 * 
	 * @param string $path 			: Chemin vers le fichier
	 * @param boolean $binary_file 	: On spcifie si on charge un fichier binaire (pour windows)
	 * 
	 * @access public
	 * 
	 * @return string
	 */
	function loadfile($path, $binary_file = false)
	{
		$mode = ( $binary_file ) ? 'rb' : 'r'; 
		
		if( !($fp = @fopen($path, $mode)) )
		{
			$this->error('loadfile()', 'Lecture du fichier "' . basename($path) . '" impossible'); 
			return false;
		}
		
		$content = fread($fp, filesize($path)); 
		fclose($fp); 
		
		return $content; 
	}
	
	/*
	 * Mailer : set_smtp()
	 * 
	 * @param string $host 	: Nom du serveur SMTP
	 * @param integer $port : Port de connexion ( 25 dans la grande majorit des cas )
	 * @param string $user 	: Login d'authentification ( si AUTH est support par le serveur )
	 * @param string $pass 	: Password d'authentification ( si AUTH est support par le serveur )
	 * 
	 * @access public
	 * 
	 * @return void
	 */
	function set_smtp($host = '', $port = '', $user = '', $pass = '')
	{
		$this->smtp_mode = true; 
		
		$this->smtp_data['host'] = ( $host != '' ) ? $host : $this->smtp_data['host']; 
		$this->smtp_data['port'] = ( $port != '' ) ? $port : $this->smtp_data['port']; 
		$this->smtp_data['user'] = ( $user != '' ) ? $user : $this->smtp_data['user']; 
		$this->smtp_data['pass'] = ( $pass != '' ) ? $pass : $this->smtp_data['pass']; 		
	}
	
	/*
	 * Mailer : mime_type()
	 * 
	 * @param string $ext 	: Extension de fichier
	 * 
	 * @access public
	 * 
	 * @return string
	 */
	function mime_type($ext)
	{
		//
		// Tableau des extensions et de leur Mime-Type
		// Rien ne vous interdit d'en rajouter si besoin est.
		//
		$mime_type_ary = array(
			'txt'  => 'text/plain', 
			'rtx'  => 'text/richtext', 
			'html' => 'text/html', 
			'htm'  => 'text/html', 
			'xml'  => 'text/xml', 
			'xls'  => 'text/xml', 
			'tsv'  => 'text/tab-separated-value', 
			'etx'  => 'text/x-setext', 
			
			'eml'  => 'message/rfc822', 
			'nws'  => 'message/rfc822', 
			
			'bmp'  => 'image/bmp', 
			'pcx'  => 'image/bmp', 
			'gif'  => 'image/gif', 
			'ief'  => 'image/ief', 
			'jpeg' => 'image/jpeg', 
			'jpg'  => 'image/jpeg', 
			'jpe'  => 'image/jpeg', 
			'png'  => 'image/png', 
			'tiff' => 'image/tiff', 
			'tif'  => 'image/tiff', 
			'cmu'  => 'image/x-cmu-raster', 
			'pnm'  => 'image/x-portable-anymap', 
			'pbm'  => 'image/x-portable-bitmap', 
			'pgm'  => 'image/x-portable-graymap', 
			'ppm'  => 'image/x-portable-pixmap', 
			'rgb'  => 'image/x-rgb', 
			'xbm'  => 'image/x-xbitmap', 
			'xpm'  => 'image/x-xpixmap', 
			'xwd'  => 'image/x-xwindowdump', 
			
			'dwg'  => 'application/acad', 
			'ccad' => 'application/clariscad', 
			'drw'  => 'application/drafting', 
			'dxf'  => 'application/dxf', 
			'xls'  => 'application/excel', 
			'hdf'  => 'application/hdf', 
			'unv'  => 'application/i-deas', 
			'igs'  => 'application/iges', 
			'iges' => 'application/iges', 
			'doc'  => 'application/msword', 
			'dot'  => 'application/msword', 
			'wrd'  => 'application/msword', 
			'oda'  => 'application/oda', 
			'pdf'  => 'application/pdf', 
			'ppt'  => 'application/powerpoint', 
			'ai'   => 'application/postscript', 
			'eps'  => 'application/postscript', 
			'ps'   => 'application/postscript', 
			'rtf'  => 'application/rtf', 
			'rm'   => 'application/vnd.rn-realmedia', 
			'dvi'  => 'application/x-dvi', 			
			'gtar' => 'application/x-gtar', 
			'tgz'  => 'application/x-gtar', 
			'swf'  => 'application/x-shockwave-flash', 
			'tar'  => 'application/x-tar', 
			'gz'   => 'application/x-gzip-compressed', 
			'zip'  => 'application/x-zip-compressed', 
			
			'au'   => 'audio/basic', 
			'snd'  => 'audio/basic', 
			'aif'  => 'audio/x-aiff', 
			'aiff' => 'audio/x-aiff', 
			'aifc' => 'audio/x-aiff', 			
			'wma'  => 'audio/x-ms-wma', 
			
			'mpeg' => 'video/mpeg', 
			'mpg'  => 'video/mpeg', 
			'mpe'  => 'video/mpeg', 
			'mov'  => 'video/quicktime', 
			'avi'  => 'video/msvideo', 
			'movie'=> 'video/x-sgi-movie', 
			
		  	'unknow' => 'application/octet-stream', 
		  //'unknow' => 'application/x-unknown-content-type' 
		);
		
		return ( !empty($mime_type_ary[$ext]) ) ? $mime_type_ary[$ext] : $mime_type_ary['unknow']; 
	}
	
	/*
	 * Mailer : set_format()
	 * 
	 * @param string/integer $format : Format de l'email
	 * 
	 * @access public
	 * 
	 * @return void
	 */
	function set_format($format)
	{
		$format = strtolower($format);
		
		switch($format)
		{
			case 'alt':
			case 3:
				$this->format = 3; 
				break;
			
			case "html":
			case "htm":
			case 2:
				$this->format = 2;
				break;
			
			case "texte":
			case "txt":
			case "text":
			case 1:
			default:
				$this->format = 1;
				break;
		}
	}
	
	/*
	 * Mailer : set_from()
	 * 
	 * @param string $email_from 	: Email de l'expditeur
	 * @param string $name_from 	: Personnalisation du nom de l'expditeur
	 * 
	 * @access public
	 * 
	 * @return void
	 */
	function set_from($email_from, $name_from = '')
	{
		$this->from['email'] = trim($email_from); 
		$this->from['name']  = trim($name_from); 
	}
	
	/*
	 * Mailer : set_to()
	 * 
	 * @param string/array $email_mixed	: Email du destinataire ou tableau contenant la liste des destinataires 
	 * 									  avec ventuellement leur nom en index 
	 * @param string $type				: Type de destinataire : to, cc, ou bcc
	 * 
	 * @access public
	 * 
	 * @return void
	 */
	function set_to($email_mixed, $type = 'to')
	{
		$type = strtolower($type); 
		if( $type != 'cc' && $type != 'bcc' && $type != 'to' )
		{
			$type = 'to'; 
		}
		
		if( !is_array($email_mixed) )
		{
			$email_mixed = array(0 => $email_mixed); 
		}
		
		foreach( $email_mixed AS $name => $email )
		{
			$name = ( !is_numeric($name) ) ? $name : ''; 
			
			$this->to[$type][] = array(
				'email' => trim($email),
				'name'  => trim($name)
			);
		}
	}
	
	/*
	 * Mailer : set_subject()
	 * 
	 * @param string $subject : Le sujet de l'email
	 * 
	 * @access public
	 * 
	 * @return void
	 */
	function set_subject($subject)
	{
		$this->subject = trim($subject); 
		$this->subject = preg_replace("/[\t\r\n]/", '', $this->subject); 
		$this->subject = '=?' . $this->charset . '?Q?' . $this->make_encoding('quoted-printable', $this->subject) . '?='; 
	}
	
	/*
	 * Mailer : set_message()
	 * 
	 * @param string $var 		: contient soit le message, soit le nom du fichier modle  utiliser
	 * @param array $vararray 	: Tableau contenant les variables  remplacer dans le modle
	 * 
	 * @access public
	 * 
	 * @return void
	 */
	function set_message($var, $vararray = '')
	{
		if( is_array($vararray) )
		{
			$this->message = array(); 
			
			$this->message['file'] = $var; 
			$this->message['vars'] = $vararray; 
			
			$this->altmessage = array(); 
			
			$this->altmessage['file'] = $var; 
			$this->altmessage['vars'] = $vararray; 
		}
		else
		{
			$this->message = trim($var); 
		}
	}
	
	/*
	 * Mailer : set_Altmessage()
	 * 
	 * @param string $var 		: contient soit le message, soit le nom du fichier modle  utiliser
	 * @param array $vararray 	: Tableau contenant les variables  remplacer dans le modle
	 * 
	 * @access public
	 * 
	 * @return void
	 */
	function set_Altmessage($var, $vararray = '')
	{
		if( is_array($vararray) )
		{
			$this->altmessage = array(); 
			
			$this->altmessage['file'] = $var; 
			$this->altmessage['vars'] = $vararray; 
		}
		else
		{
			$this->altmessage = trim($var); 
		}
	}
	
	/*
	 * Mailer : compile_msg()
	 * 
	 * @param string $tpl_type	: Type du modle 
	 * 
	 * @access private
	 * 
	 * @return string
	 */
	function compile_msg($tpl_type = 0)
	{
		if( $tpl_type == WM_TPL_ALT )
		{
			$dir 	  = $this->root_text; 
			$msg_data = $this->altmessage; 
		}
		else
		{
			$dir 	  = $this->root_html; 
			$msg_data = $this->message; 
		}
		
		if( is_array($msg_data) )
		{
			if( !($this->set_path_template($dir, $tpl_type)) )
			{
				return false; 
			}
			
			$message = $this->loadfile($dir . $msg_data['file']); 
			
			foreach( $msg_data['vars'] AS $key => $val )
			{
				$key = '%'.$key.'%';
				$message = str_replace($key, $val, $message);
			}
		}
		else
		{
			$message = $msg_data; 
		}
				
		return trim($message); 
	}
	
	/* 
	 * Mailer : make_encoding()
	 * 
	 * @param string $encoding	: Type d'encodage dsir
	 * @param string $str		: Chane  encoder
	 * 
	 * @access public
	 * 
	 * @return string
	 */
	function make_encoding($encoding, $str)
	{
		switch($encoding)
		{
			case '7bit':
			case '8bit':
				$str = preg_replace("/\r(\n)?/", "\n", $str); 
				break;
			
			case 'base64':
				$str = chunk_split(base64_encode($str)); 
				break;
			
			case 'quoted-printable':
				$str = $this->make_encoding('8bit', $str); 
				if( @extension_loaded('imap') && @function_exists('imap_8bit') )
				{
					$str = imap_8bit($str); 
				}
				else
				{
					$str = preg_replace('/([\000-\010\013\014\016-\037\075\177-\377])/e', "'=' . sprintf('%02X', ord('\\1'));", $str); 
					//$this->encoding = '8bit';
				}
				break;
		}
		
		return $str; 
	}
	
	/*
	 * Mailer : attachment()
	 * 
	 * @param string $path			: Chemin vers le fichier
	 * @param string $filename		: Nom du fichier
	 * @param string $disposition	: Disposition
	 * @param string $mime_type		: Mime-type
	 * @param bool	 $embedded		: true si fichier incorpor dans l'email html
	 * 
	 * @access public
	 *  
	 * @return void
	 */
	function attachment($path, $filename = '', $disposition = '', $mime_type = '', $embedded = false)
	{
		if( $this->set_file($path) )
		{
			$this->attachfile['path'][] 		= $path; 
			$this->attachfile['name'][] 		= ( $filename != '' ) ? trim($filename) : basename($path); 
			$this->attachfile['disposition'][] 	= ( $disposition == 'inline' ) ? 'inline' : 'attachment'; 
			$this->attachfile['mimetype'][] 	= $mime_type; 
			$this->attachfile['cid'][] 			= ( $embedded ) ? $this->generate_cid() : ''; 
		}
	}
	
	/*
	 * Mailer : generate_cid()
	 * 
	 * @access private
	 *  
	 * @return string
	 */	
	function generate_cid()
	{
		$chars = array(
			'A','B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O','P', 'Q', 'R', 
			'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z', '2', '3', '4', '5', '6', '7', '8', '9', '0'); 
		
		$max_chars = count($chars) - 1;
		srand( (double) microtime()*1000000);
		
		$cid = '';
		for($i = 0; $i < 20; $i++)
		{
			if( in_array($i, array(8, 12)) )
			{
				$cid .= '-'; 
			}
			else
			{
				$cid .= $chars[rand(0, $max_chars)];
			}			
		}
		
		return $cid; 
	}
	
	/*
	 * Mailer : set_reply_to()
	 * 
	 * @param string $email_reply	: email de rponse
	 * 
	 * @access public
	 * 
	 * @return void
	 */
	function set_reply_to($email_reply = '')
	{
		if( $email_reply == '' )
		{
			$email_reply = $this->from['email']; 
		}
		
		$this->headers['Reply-To'] = $email_reply; 
	}
	
	/*
	 * Mailer : set_return_path()
	 * 
	 * @param string $email_return	: email de retour d'erreur
	 * 
	 * @access public
	 * 
	 * @return void
	 */
	function set_return_path($email_return = '')
	{
		if( $email_return == '' )
		{
			$email_return = $this->from['email']; 
		}
		
		$this->headers['Return-Path'] = '<' . $email_return . '>'; 
	}
	
	/*
	 * Mailer : set_notify()
	 * 
	 * @param string $email_notify	: email pour le retour de notification de lecture 
	 * 						  		  (par dfaut, l'adresse d'envoi est utilise)
	 * 
	 * @access public
	 * 
	 * @return void
	 */
	function set_notify($email_notify = '')
	{
		if( $email_notify == '' )
		{
			$email_notify = $this->from['email']; 
		}
		
		$this->headers['Disposition-Notification-To'] = '<' . $email_notify . '>'; 
	}
	
	/*
	 * Mailer : organization()
	 * 
	 * @param string $soc
	 * 
	 * @access public
	 * 
	 * @return void
	 */
	function organization($soc)
	{
		$this->headers['Organization'] = $soc;
	}
	
	/*
	 * Mailer : set_priority()
	 * 
	 * @param string ou integer $level : Niveau de priorit de l'email
	 * 
	 * @access public
	 * 
	 * @return void
	 */
	function set_priority($level)
	{
		if( is_numeric($level) )
		{
			if( $level > 0 && $level <= 5 )
			{
				$this->headers['X-Priority'] = $level; 
			}
		}
		else
		{
			$level = strtolower($level); 
			
			switch($level)
			{
				case 'highest':
					$this->headers['X-MSMail-Priority'] = 'Highest';
					break;
				
				case 'hight':
					$this->headers['X-MSMail-Priority'] = 'High';
					break;
				
				case 'low':
					$this->headers['X-MSMail-Priority'] = 'Low';
					break;
				
				case 'lowest':
					$this->headers['X-MSMail-Priority'] = 'Lowest';
					break;
				
				case 'normal':
				default:
					$this->headers['X-MSMail-Priority'] = 'Normal';
					break;
			}
		}
	}
	
	/*
	 * Mailer : set_header()
	 * 
	 * @param string $header : Nom de l'entte  modifier
	 * @param string $str	 : Contenu de l'entte
	 * 
	 * @access public
	 * 
	 * @return void
	 */
	function set_header($header, $str)
	{
		if( $header != '' && $str != '' )
		{
			if( strpos($header, '-') )
			{
				$elt = explode('-', $header);
				
				$item = array(); 
				foreach( $elt AS $val )
				{
					$item[] = ucfirst($val); 
				}
				
				$header = implode('-', $item); 
			}
			else
			{
				$header = ucfirst($header);
			}
			
			$this->headers[$header] = $str;
		}
	}
	
	/*
	 * Mailer : send()
	 * 
	 * @param boolean $do_not_send	: true -> affiche l'entte et le corp du message au lieu de l'envoyer 
	 * 
	 * @access public
	 * 
	 * @return boolean
	 */
	function send($do_not_send = false)
	{
		if( $this->from['email'] == '' )
		{
			$this->error('send()', "Aucune adresse expditrice indique"); 
			return false;
		}
		
		if( !count($this->to['to']) )
		{
			$this->to['to'][] = array(
				'email' => $this->from['email'],
				'name' => $this->from['name']
			);
		}
		
		if( $this->subject == '' )
		{
			$this->error('send()', "Aucun sujet spcifi"); 
			return false;
		}
		
		if( !$this->message )
		{
			$this->error('send()', "Aucun message spcifi"); 
			return false;
		}
		
		$to_ary = array();
		foreach( $this->to['to'] AS $to_data )
		{
			$to_ary[] = ( ( !stristr(PHP_OS, 'win') && $to_data['name'] != '' ) ? '"' . $to_data['name'] . '" ' : '' ) . '<' . $to_data['email'] . '>'; 
		}
		$to_list = implode(', ', $to_ary); 
		
		$this->build_headers($to_list);
		$this->build_message(); 
		
		if( $this->statut )
		{
			if( $do_not_send )
			{
				echo nl2br(htmlentities($this->headers)) . '<br /><br />' . nl2br(htmlentities($this->message)); 
				exit;
			}
			
			if( $this->smtp_mode )
			{
				$smtp = new Smtp($this->smtp_data['host'], $this->smtp_data['port'], $this->smtp_data['user'], $this->smtp_data['pass'], $this->server); 
				
				$result = $smtp->mailsmtp($this->to, $this->subject, $this->message, $this->headers, $this->from['email']); 
			}
			else if( $this->hebergeur == WM_HOST_OTHER )
			{
				$result = @mail($to_list, $this->subject, $this->message, $this->headers);
			}
			else if( $this->hebergeur == WM_HOST_ONLINE )
			{
				$result = @email($this->from_online, $to_list, $this->subject, $this->message, $this->reply_online, $this->headers); 
			}
			else if( $this->hebergeur == WM_HOST_NEXEN )
			{
				include_once('mail.inc'); 
				$result = @email($to_list, $this->subject, $this->message, $this->headers);
			}
			else
			{
				$this->error('send()', 'Aucune fonction d\'envoi n\'est dfinie'); 
				$result = false;
			}
		}
		else
		{
			$result = false; 
		}
		
		if( !$result && !empty($php_errormsg) )
		{
			$this->error('send()', $php_errormsg); 
		}
		
		return $result; 
	}
	
	/*
	 * Mailer : build_headers()
	 * 
	 * @param string $to_list	: Liste des adresses des destinataires, de la forme : <adresse@domain.com>, ...
	 * 
	 * @access private
	 * 
	 * @return void
	 */
	function build_headers($to_list)
	{
		global $HTTP_SERVER_VARS, $HTTP_ENV_VARS; 
		
		if( $this->hebergeur == WM_HOST_ONLINE )
		{
			list($account) = explode('@', $this->from['email']); 
			$this->from_online = $this->reply_online = $account; 
		}
		else
		{
			$this->headers['From']     = ( $this->from['name'] != '' ) ? '"' . $this->from['name'] . '" ' : ''; 
			$this->headers['From'] 	  .= '<' . $this->from['email'] . '>'; 
			$this->headers['X-Sender'] = '<' . $this->from['email'] . '>'; 
			
			if( empty($this->headers['Reply-To']) )
			{
				$this->headers['Reply-To']  = $this->from['email']; 
			}
			
			if( empty($this->headers['Return-Path']) )
			{
				$this->headers['Return-Path'] = $this->from['email']; 
			}
		}
		
		if( $this->smtp_mode )
		{
			$this->headers['Subject'] = $this->subject; 
			$this->headers['To'] 	  = $to_list; 
		}
		
		if( count($this->to['cc']) > 0 )
		{
			$cc_ary = array(); 
			foreach( $this->to['cc'] AS $cc_data )
			{
				$cc_ary[] = ( ($cc_data['name'] != '' ) ? '"' . $cc_data['name'] . '" ' : '' ) . '<' . $cc_data['email'] . '>'; 
			}
			
			$this->headers['Cc'] = implode(', ', $cc_ary); 
		}
		
		if( count($this->to['bcc']) > 0 && !$this->smtp_mode )
		{
			$bcc_ary = array(); 
			foreach( $this->to['bcc'] AS $bcc_data )
			{
				$bcc_ary[] = ( ( $bcc_data['name'] != '' ) ? '"' . $bcc_data['name'] . '" ' : '' ) . '<' . $bcc_data['email'] . '>'; 
			}
			
			$this->headers['Bcc'] = implode(', ', $bcc_ary); 
		}
		
		if( !empty($HTTP_SERVER_VARS['HTTP_HOST']) || !empty($HTTP_ENV_VARS['HTTP_HOST']) )
		{
			$server = ( !empty($HTTP_SERVER_VARS['HTTP_HOST']) ) ? $HTTP_SERVER_VARS['HTTP_HOST'] : $HTTP_ENV_VARS['HTTP_HOST'];
		}
		else if( !empty($HTTP_SERVER_VARS['SERVER_NAME']) || !empty($HTTP_ENV_VARS['SERVER_NAME']) )
		{
			$server = ( !empty($HTTP_SERVER_VARS['SERVER_NAME']) ) ? $HTTP_SERVER_VARS['SERVER_NAME'] : $HTTP_ENV_VARS['SERVER_NAME'];
		}		
		else
		{
			$server = '';
		}
		
		$this->server = ( $server != '' ) ? $server : $this->server;
		
		$sender_ip = ( !empty($HTTP_SERVER_VARS['REMOTE_ADDR']) ) ? $HTTP_SERVER_VARS['REMOTE_ADDR'] : ( ( !empty($HTTP_ENV_VARS['REMOTE_ADDR']) ) ? $HTTP_ENV_VARS['REMOTE_ADDR'] : '' );
		
		$this->headers['X-Mailer']		= "WAmailer/" . $this->version . " PHP/" . phpversion(); 
		$this->headers['X-AntiAbuse']	= "Sender IP - $sender_ip Server Name - <$server>";
		$this->headers['Date']			= date('D, d M Y H:i:s O', time());
		$this->headers['MIME-Version']	= '1.0'; 
		
		$this->boundary_attach	= "-----=_attach_" . md5( uniqid ( rand() ) );
		$this->boundary_alt		= "-----=_alt_" . md5( uniqid ( rand() ) );
		
		if( count($this->attachfile['path']) > 0 )
		{
			$this->headers['Content-Type'] = "multipart/mixed;\n\tboundary=\"" . $this->boundary_attach . '"'; 
		}
		else
		{
			if( $this->format == 3 )
			{
				if( $this->message && $this->altmessage )
				{
					$this->headers['Content-Type'] = "multipart/alternative;\n\tboundary=\"" . $this->boundary_alt . '"'; 
				}
				else
				{
					$this->format = 2; 
				}
			}
			
			if( $this->format == 2 )
			{
				$this->headers['Content-Type'] = "text/html; charset=\"" . $this->charset . '"'; 
				$this->headers['Content-Transfer-Encoding'] = $this->encoding; 
			}
			else if( $this->format == 1 )
			{
				$this->headers['Content-Type'] = "text/plain; charset=" . $this->charset; 
				$this->headers['Content-Transfer-Encoding'] = $this->encoding; 
			}
		}
		
		$i = 0; 
		$headers = ''; 
		$total_headers = count($this->headers); 
		foreach( $this->headers AS $title_header => $content_header )
		{
			$headers .= $title_header . ': ' . $content_header;
			$headers .= ( ($i + 1) < $total_headers ) ? "\n" : ''; 
			$i++;
		}
		
		$this->headers = $headers; 
	}
	
	/*
	 * Mailer : build_message()
	 * 
	 * @access private
	 * 
	 * @return booleen
	 */
	function build_message()
	{
		$total_attach = count($this->attachfile['path']); 
		
		if( $this->format == 3 )
		{
			if( !($this->message = $this->compile_msg(WM_TPL_HTML)) )
			{
				return false; 
			}
			
			if( !($this->altmessage = $this->compile_msg(WM_TPL_ALT)) )
			{
				return false; 
			}
			
			$message  = '--' . $this->boundary_alt . "\n";
			$message .= 'Content-Type: text/plain; charset=' . $this->charset . "\n";
			$message .= 'Content-Transfer-Encoding: ' . $this->encoding . "\n\n";
			$message .= $this->make_encoding($this->encoding, $this->altmessage);
			$message .= "\n\n";
			$message .= '--' . $this->boundary_alt . "\n";
			$message .= 'Content-Type: text/html; charset="' . $this->charset . "\"\n";
			$message .= 'Content-Transfer-Encoding: ' . $this->encoding . "\n\n";
			$message .= $this->make_encoding($this->encoding, $this->message);
			$message .= "\n\n";
			$message .= '--' . $this->boundary_alt . "--\n"; 
			
			$this->message = $message;
		}
		else
		{
			if( !($this->message = $this->compile_msg()) )
			{
				return false; 
			}
			
			$this->message = $this->make_encoding($this->encoding, $this->message);
		}
		
		if( $total_attach > 0 )
		{
			$message = '--' . $this->boundary_attach . "\n";
			
			if( $this->format == 3 )
			{
				$message .= "Content-Type: multipart/alternative;\n\tboundary=\"" . $this->boundary_alt . "\"\n\n"; 
			}
			else if( $this->format == 2 )
			{
				$message .= 'Content-Type: text/html; charset="' . $this->charset . "\"\n";
				$message .= 'Content-Transfer-Encoding: ' . $this->encoding . "\n\n";
			}
			else
			{
				$message .= 'Content-Type: text/plain; charset=' . $this->charset . "\n";
				$message .= 'Content-Transfer-Encoding: ' . $this->encoding . "\n\n";
			}
			
			$message .= $this->message;
			$message .= "\n\n";
			
			for( $i = 0; $i < $total_attach; $i++ )
			{
				$filename = $this->attachfile['name'][$i]; 
				$file_str = $this->make_encoding('base64', $this->loadfile($this->attachfile['path'][$i], true)); 
				
				if( $this->attachfile['mimetype'][$i] != '' )
				{
					$mime_type = $this->attachfile['mimetype'][$i];
				}
				else
				{
					$extension = ''; 
					if( $pos = strrpos($filename, '.') )
					{
						$extension = strtolower(substr($filename, $pos+1)); 						
					}
					
					$mime_type = $this->mime_type($extension); 
				}
				
				$message .= '--' . $this->boundary_attach . "\n"; 
				$message .= 'Content-Type: ' . $mime_type . '; name="' . $filename . "\"\n"; 
				$message .= "Content-Transfer-Encoding: base64\n"; 
				
				if( $this->attachfile['cid'][$i] != '' )
				{
					$message .= 'Content-ID: <' . $this->attachfile['cid'][$i] . ">\n\n"; 
				}
				else
				{
					$message .= 'Content-Disposition: ' . $this->attachfile['disposition'][$i] . '; filename="' . $filename . "\"\n\n";	
				}
				
				$message .= $file_str;
				$message .= "\n\n";

			}
			
			$message .= '--' . $this->boundary_attach . "--\n";
			
			$this->message = $message;
		}
		
		if( $this->format == 3 || $total_attach > 0 )
		{
			$this->message = "This is a multi-part message in MIME format.\n\n" . $this->message;
		}
		
		return true; 
	}
	
	/*
	 * Mailer : clear_all()
	 * 
	 * @access public
	 * 
	 * @return void
	 */
	function clear_all()
	{
		$this->to 				= array('to'  => array(), 'cc'  => array(), 'bcc' => array()); 
		$this->subject 			= '';
		$this->message 			= '';
		$this->altmessage 		= '';
		$this->attachfile 		= array('path' => array(), 'name' => array(), 'disposition' => array(), 'mimetype' => array(), 'cid' => array());
		$this->boundary_attach 	= '';
		$this->boundary_alt		= '';
		$this->headers 			= array();		
		$this->mail_reponse 	= '';
		$this->statut 			= true; 
	}
	
	/*
	 * Mailer : clear_from()
	 * 
	 * @access public
	 * 
	 * @return void
	 */
	function clear_from()
	{
		$this->from_online		= ''; 
		$this->reply_online		= ''; 
		$this->from				= array('email' => '', 'name' => '');
		
		$this->message 			= '';
		$this->altmessage 		= '';		
		$this->boundary_attach 	= '';
		$this->boundary_alt		= '';		
		$this->headers 			= array();		
		$this->mail_reponse		= '';
		$this->statut 			= true; 
	}
	
	/*
	 * Mailer : clear_to()
	 * 
	 * @access public
	 * 
	 * @return void
	 */
	function clear_to()
	{
		$this->to 				= array('to'  => array(), 'cc'  => array(), 'bcc' => array()); 
		
		$this->message 			= '';
		$this->altmessage 		= '';		
		$this->boundary_attach 	= '';
		$this->boundary_alt		= '';		
		$this->headers 			= array();		
		$this->mail_reponse		= '';
		$this->statut 			= true; 
	}
	
	/*
	 * Mailer : clear_subject()
	 * 
	 * @access public
	 * 
	 * @return void
	 */
	function clear_subject()
	{
		$this->subject 			= ''; 
		
		$this->message 			= '';
		$this->altmessage 		= '';		
		$this->boundary_attach 	= '';
		$this->boundary_alt		= '';		
		$this->headers 			= array();		
		$this->mail_reponse		= '';
		$this->statut 			= true; 
	}
	
	/*
	 * Mailer : clear_attach()
	 * 
	 * @access public
	 * 
	 * @return void
	 */
	function clear_attach()
	{
		$this->attachfile 		= array('path' => array(), 'name' => array(), 'disposition' => array(), 'mimetype' => array(), 'cid' => array());
		
		$this->message 			= '';
		$this->altmessage 		= '';		
		$this->boundary_attach 	= '';
		$this->boundary_alt		= '';		
		$this->headers 			= array();		
		$this->mail_reponse		= '';
		$this->statut 			= true; 
	}
	
	/*
	 * Mailer : error()
	 * 
	 * @param string $fct 	: La dernire fonction o s'est produite l'erreur
	 * @param string $error : Le message d'erreur  afficher si mode debug
	 * 
	 * @access private
	 * 
	 * @return void
	 */
	function error($fct, $error)
	{
		$this->mail_reponse = sprintf("<br /><br />%s <b>Erreur</b> : %s", $fct, $error); 
		
		$this->statut = false; 
		
		if( $this->debug )
		{
			exit($this->mail_reponse); 
		}
	}
}// fin de classe

class Smtp extends Mailer {
	
	/*
	 * Les sources qui m'ont bien aides : 
	 * 
	 * @link : http://www.rfc-editor.org/
	 * @link : http://strasbourg.ort.asso.fr/examen2000/np.html#SMTP
	 * @link : http://www.commentcamarche.net/internet/smtp.php3
	 * @link : http://abcdrfc.free.fr/
	 * @link : http://www.interpc.fr/mapage/billaud/telmail.htm
	 *
	 * Toutes les commandes de connexion et de dialogue avec le serveur sont 
	 * dtailles dans la RFC 821.
	 * 
	 * Les commandes d'authentification au serveur sont dtailles dans 
	 * la RFC 2554 ( note: Impossible de trouver cette fichu RFC 2554 en franais ou 
	 * de trouver des infos satisfaisantes sur la commande AUTH ).
	 * 
	 * @link : http://www.rfc-editor.org/rfc/rfc2554.txt
	 * 
	 */	
	
	/*
     * Identifiant de connexion
     *
     * @var	resource $connect_id
	 * @access private
     */
	var $connect_id		= ''; 
	
	/*
	 * Mailer : smtp()
	 * 
	 * @param string $smtp_server	: Nom du serveur smtp 
	 * @param integer $smtp_port	: Numro du port smtp 
	 * @param string $smtp_user		: Nom d'utilisateur (Si AUTH autoris) 
	 * @param string $smtp_pass		: Mot de passe (Si AUTH autoris) 
	 * @param string $server_from	: Nom du serveur metteur 
	 * 
	 * @access private
	 * 
	 * @return boolean
	 */
	function smtp($smtp_server, $smtp_port, $smtp_user, $smtp_pass, $server_from)
	{
		if( !is_resource($this->connect_id) )
		{
			$result = $this->connect_to_smtp($smtp_server, $smtp_port, $smtp_user, $smtp_pass, $server_from); 
			
			if( $result['error'] )
			{
				$this->error('connect_to_smtp()', $result['message']); 
				return false; 
			}
			
			$this->connect_id = $result['connect_id']; 
		}
		
		return true; 
	}
	
	/*
	 * Mailer : connect_to_smtp()
	 * 
	 * @param string $smtp_server	: Nom du serveur smtp 
	 * @param integer $smtp_port	: Numro du port smtp 
	 * @param string $smtp_user		: Nom d'utilisateur (Si AUTH autoris) 
	 * @param string $smtp_pass		: Mot de passe (Si AUTH autoris) 
	 * @param string $server_from	: Nom du serveur metteur 
	 * 
	 * @access private
	 * 
	 * @return array
	 */
	function connect_to_smtp($smtp_server, $smtp_port, $smtp_user, $smtp_pass, $server_from)
	{
		// Ouverture de la connexion au serveur SMTP
		if( !($connect_id = @fsockopen($smtp_server, $smtp_port, $errno, $errstr, 2)) )
		{
			return array('error' => true, 'message' => "Echec lors de la connexion au serveur smtp : $errno $errstr"); 
		}
		
		// 
		// Code success : 220
		// Code failure : 421
		// 
		$result = $this->send_data($connect_id, '', 220); 
		if( $result['error'] )
		{
			return array('error' => true, 'message' => $result['message']); 
		}
		
		// 
		// Comme on est poli, on dit bonjour, et on s'authentifie le cas chant 
		// 
		// Code success	: 250
        // Code error	: 500, 501, 504, 421
		//
		
		if( !empty($smtp_user) && !empty($smtp_pass) )
		{
			$result = $this->send_data($connect_id, "EHLO \r\n", 250); 
			if( $result['error'] )
			{
				return array('error' => true, 'message' => $result['message']); 
			}
			
			$result = $this->send_data($connect_id, "AUTH LOGIN\r\n", 334); 
			if( $result['error'] )
			{
				return array('error' => true, 'message' => $result['message']); 
			}
			
			$result = $this->send_data($connect_id, base64_encode($smtp_user) . "\r\n", 334); 
			if( $result['error'] )
			{
				return array('error' => true, 'message' => $result['message']); 
			}
			
			$result = $this->send_data($connect_id, base64_encode($smtp_pass) . "\r\n", 235); 
			if( $result['error'] )
			{
				return array('error' => true, 'message' => $result['message']); 
			}
		}
		else
		{
			$result = $this->send_data($connect_id, "HELO \r\n", 250); 
			if( $result['error'] )
			{
				return array('error' => true, 'message' => $result['message']); 
			}
		}
		
		return array('error' => false, 'connect_id' => $connect_id); 
	}
	
	/*
	 * Mailer : send_data()
	 * 
	 * @param resource $connect_id	: Identifiant de connexion au serveur 
	 * @param integer $input 		: Les donnes  envoyer 
	 * 
	 * @access private
	 * 
	 * @return array
	 */
	function send_data($connect_id, $input)
	{
		if( $input != '' )
		{
			fputs($connect_id, $input); 
		}
		
		$num_args = func_num_args(); 
		
		if( $num_args > 2 )
		{
			$code_accept = array(); 
			for( $i = 2; $i < $num_args; $i++ )
			{
				$arg = func_get_arg($i); 
				if( is_numeric($arg) )
				{
					$code_accept[] = $arg; 
				}
			}
			
			$output = ''; 
			while( substr($output, 3, 1) != ' ' )
			{
				$output = fgets($connect_id, 512); 
				
				//echo $output . '<br>';  flush(); 
			}
			
			if( !in_array(substr($output, 0, 3), $code_accept) )
			{
				return array('error' => true, 'message' => 'SMTP Error : ' . nl2br(htmlentities($output))); 
			}
		}
		
		return array('error' => false); 
	}
	
	/*
	 * Mailer : mailsmtp()
	 *
	 * Description : Envoi d'emails via connexion au serveur smtp dfini.
	 * 
	 * @param array $to			: tableau contenant la liste des adresses directe (to), la liste des 
	 * 							  copie (cc) et la liste des copies caches (bcc)
	 * @param string $subject 	: Le sujet de l'email
	 * @param string $message 	: Le message construit (fichier attach ou pas, etc...)
	 * @param array $headers 	: Le tableau contenant les entetes
	 * @param string $from 		: Adresse d'envoi 
	 * 
	 * @access private
	 * 
	 * @return boolean
	 */	
	function mailsmtp($to, $subject, $message, $headers, $from)
	{
		//
		// On spcifie l'adresse de l'expditeur
		//
		// Code success	: 250
        // Code failure	: 552, 451, 452
        // Code error	: 500, 501, 421
		//
		$result = $this->send_data($this->connect_id, 'MAIL FROM: <' . $from . ">\r\n", 250); 
		if( $result['error'] )
		{
			$this->error('mailsmtp()', $result['message']); 
			return false; 
		}
		
		//
		// On spcifie les destinatires au serveur smtp
		//
		// Code success	: 250, 251
        // Code failure	: 550, 551, 552, 553, 450, 451, 452
        // Code error	: 500, 501, 503, 421
		// 
		foreach( $to AS $emails_ary )
		{
			foreach( $emails_ary AS $email_data )
			{
				$result = $this->send_data($this->connect_id, 'RCPT TO: <' . $email_data['email'] . ">\r\n", 250, 251); 
				if( $result['error'] )
				{
					$this->error('mailsmtp()', $result['message']); 
					return false; 
				}
			}
		}
		
		//
		// On indique au serveur que l'on va lui livrer les donnes
		//
		// Code intermdiaire 	: 354
		//
		$result = $this->send_data($this->connect_id, "DATA\r\n", 354); 
		if( $result['error'] )
		{
			$this->error('mailsmtp()', $result['message']); 
			return false; 
		}
		
		//
		// On envoie les enttes 
		//
		$headers = preg_replace("/(?<!\r)\n/si", "\r\n", $headers); 
		$this->send_data($this->connect_id, $headers . "\r\n\r\n"); 
		
		//
		// Et maintenant le message 
		//
		$message = preg_replace("/(?<!\r)\n/si", "\r\n", $message); 
		$this->send_data($this->connect_id, $message . "\r\n"); 

		//
		// On indique la fin de l'envoi de donnes au serveur
		//
		// Code success	: 250
        // Code failure	: 552, 554, 451, 452
        // Code error	: 500, 501, 503, 421
		//
		$result = $this->send_data($this->connect_id, ".\r\n", 250); 
		if( $result['error'] )
		{
			$this->error('mailsmtp()', $result['message']); 
			return false; 
		}
		
		//
		// Comme on est poli, on dit aurevoir au serveur avec la commande adquat QUIT 
		//
		// Code success	: 221
        // Code failure	: 500
		//
		$this->send_data($this->connect_id, "QUIT\r\n"); 
		
		fclose($this->connect_id); 
		
		$this->connected_id = ''; 
		
		return true; 
	}
}

}
?>