<?php
/*******************************************************************
 *			
 * 			Fichier			:	functions.stats.php 
 * 			Cr le			:	22 octobre 2002 
 * 			Dernire modif	:	16 avril 2003 
 * 			Email			:	wascripts@phpcodeur.net 
 * 
 * 				 Copyright 2002-2003 PHPcodeur
 * 
 *******************************************************************/

/*******************************************************************
 *  This program is free software; you can redistribute it and/or 
 * 	modify it under the terms of the GNU General Public License as 
 * 	published by the Free Software Foundation; either version 2 of 
 *  the License, or (at your option) any later version. 
 *******************************************************************/


if( !defined('FUNCTIONS_STATS_INC') )
{

define('FUNCTIONS_STATS_INC', 1); 

define('STATS_PATH', $waroot . 'stats/'); 

//
// Conversion couleur hexadcimal => rvb 
//
function rvb_color($im, $color)
{
	preg_match('/^(..)(..)(..)$/', $color, $color_parts); 
	
	return imagecolorallocate($im, hexdec($color_parts[1]), hexdec($color_parts[2]), hexdec($color_parts[3])); 
}

//
// Coordonnes du rayon 
//
function xy_arc($degre, $diametre)
{
	$x_arc = cos($degre * (pi() / 180.0)) * ($diametre / 2);
	$y_arc = sin($degre * (pi() / 180.0)) * ($diametre / 2);
	
	return array($x_arc, $y_arc); 
}

//
// Cration des fichiers de stats
//
function create_stats($liste)
{
	global $db, $nl_config; 
	
	if( $nl_config['disable_stats'] || !@extension_loaded('gd') )
	{
		return false; 
	}
	
	@set_time_limit(0); 
	
	$sql = "SELECT MIN(a.abo_register_date) AS first_abo 
			FROM " . ABONNES_TABLE . " AS a, " . ABO_LISTE_TABLE . " AS al 
			WHERE al.liste_id = $liste AND a.abo_id = al.abo_id AND a.abo_status = " . ABO_ACTIF; 
	if( $result = $db->query($sql) )
	{
		if( !($first_abo = $db->result($result, 0, 'first_abo')) )
		{
			$first_abo = time(); 
		}
		
		$last_m = date('m'); 
		$last_y = date('Y'); 
		
		$m = date('m', $first_abo); 
		$y = date('Y', $first_abo); 
		
		@chmod(STATS_PATH, 0777); 
		
		do
		{
			$filename = date('Y_F', mktime(0, 0, 0, $m, 1, $y)) . '_list' . $liste . '.txt'; 
			
			if( !@file_exists(STATS_PATH . $filename) )
			{
				$stats = array(); 
				
				if( $fw = @fopen(STATS_PATH . $filename, 'w') )
				{
					for( $day = 1; $day <= 31; $day++ )
					{
						if( checkdate($m, $day, $y) )
						{
							$min_time = mktime(0, 0, 0, $m, $day, $y); 
							$max_time = mktime(23, 59, 59, $m, $day, $y); 
							
							$sql = "SELECT COUNT(a.abo_id) AS num_abo 
								FROM " . ABONNES_TABLE . " AS a, " . ABO_LISTE_TABLE . " AS al 
								WHERE al.liste_id = $liste AND a.abo_id = al.abo_id 
								  AND a.abo_status = " . ABO_ACTIF . " 
								  AND a.abo_register_date BETWEEN $min_time AND $max_time"; 
							if( !($result = $db->query($sql)) )
							{
								$stats[] = 0; 
							}
							else
							{
								$stats[] = $db->result($result, 0, 'num_abo'); 
							}
						}
					}
					
					$stats_string = implode("\r\n", $stats); 
					
					fwrite($fw, $stats_string); 
					fclose($fw); 
				}
			}
			
			$toc = ( $m == $last_m && $y == $last_y ) ? false : true; 
			
			$m++; 
			if( $m == 13 )
			{
				$m = 1; 
				$y++; 
			}
		}
		while( $toc ); 
	}
	
	return true; 
}

//
// Mise  jour des donnes pour les statistiques 
//
function update_stats($liste)
{
	global $nl_config; 
	
	if( $nl_config['disable_stats'] || !@extension_loaded('gd') )
	{
		return false; 
	}
	
	$filename = date('Y_F') . '_list' . $liste . '.txt'; 
	
	if( !@file_exists(STATS_PATH . $filename) )
	{
		create_stats($liste); 
	}
	else
	{
		if( $fp = @fopen(STATS_PATH . $filename, 'r') )
		{
			$stats = fread($fp, filesize(STATS_PATH . $filename)); 
			fclose($fp); 
			
			$days = explode("\r\n", $stats); 
			
			$offset = date('j'); 
			$days[--$offset] += 1; 
			
			$new_stats = implode("\r\n", $days); 
			
			@fwrite(@fopen(STATS_PATH . $filename, 'w'), $new_stats); 
		}
	}
	
	return true; 
}

//
// Suppression de stats (lors de la suppression d'une liste) 
//
function remove_stats($liste_from, $liste_to = false)
{
	global $nl_config; 
	
	if( $nl_config['disable_stats'] || !@extension_loaded('gd') )
	{
		return false; 
	}
	
	@set_time_limit(0); 
	
	$res = @opendir(STATS_PATH); 
	
	$old_stats = array(); 
	while( $stats_file = @readdir($res) )
	{
		if( preg_match("#^([0-9]{4})?_([a-z]+)?_list$liste_from\.txt$#is", $stats_file, $match) )
		{
			if( $liste_to )
			{
				if( $fp = @fopen(STATS_PATH . $match[0], 'r') )
				{
					$old_stats[$match[1] . '_' . $match[2]] = explode("\r\n", fread($fp, filesize(STATS_PATH . $match[0]))); 
					fclose($fp); 
				}
			}
			
			@unlink(STATS_PATH . $match[0]); 
		}
	}
	
	@closedir($res); 
	
	if( $liste_to && count($old_stats) )
	{
		foreach( $old_stats AS $date => $num )
		{
			$filename = $date . '_list' . $liste_to . '.txt'; 
			
			if( $fp = @fopen(STATS_PATH . $filename, 'r') )
			{
				$stats = explode("\r\n", fread($fp, filesize(STATS_PATH . $filename))); 
				
				for( $i = 0; $i < count($stats); $i++ )
				{
					$stats[$i] += ( !empty($num[$i]) ) ? $num[$i] : 0; 
				}
				
				$new_stats = implode("\r\n", $stats); 
				
				@fwrite(@fopen(STATS_PATH . $filename, 'w'), $new_stats); 
			}
		}
	}
	
	return true; 
}

}
?>